/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * diffraction gauss
 * @brief ܌tB^iKEXj
 * 
 * @param F Fl
 *
 * ܂ɂu[ʂV~[g܂D
 * i`̓KEXzłD
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
#extension GL_ARB_texture_rectangle: enable

// Screen Efects󂯎
uniform sampler2DRect se_rgbaTex;        // 1pXڂRGBA
uniform sampler2DRect se_rgbaPassTex;    // 2pXڂRGBA
uniform vec2 se_screenSize;
uniform float se_cameraZoom;
uniform float se_cameraFocus; 

// }`pX
uniform int se_pass;
const int se_maxPass = 2;

// KEX֐
float normalDistribution(const float x) {
    return 0.39894228 * exp(-0.5 * x * x);
}

/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * main
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
void main(void) {
    vec2 uvPos = gl_FragCoord.xy;
    
    float pixWidth = se_screenSize.x;
    float pixHeight = se_screenSize.y;
    float dotPitch;
    if (pixHeight < pixWidth) {
        dotPitch = 0.036 / pixWidth;
    } else {
        dotPitch = 0.036 / pixHeight;
    }
    
    // Fl
    float FValue = 1.0e+9;
    if (se_cameraFocus != 0.0) {
        FValue = 2.0 * 36.0 * (0.001 * se_cameraZoom) * (0.001 * se_cameraZoom)
                 / se_cameraFocus;
    }
    if (FValue > 512.0) {
        FValue = 512.0;
    }
    
    float dr = 2.0 * 1.2196 * 614.5e-9 * FValue;    // GA[fBXNar
    float dg = 2.0 * 1.2196 * 532.5e-9 * FValue;    // GA[fBXNag
    float db = 2.0 * 1.2196 * 467.5e-9 * FValue;    // GA[fBXNab
    float sr = 0.17219 * dr;    // W΍r
    float sg = 0.17219 * dg;    // W΍r
    float sb = 0.17219 * db;    // W΍r
    
    int iWidth = int(pixWidth);
    int iHeight = int(pixHeight);
    vec2 refPos;
    vec3 rgbReference;
    vec3 rgbDestination = vec3(0.0, 0.0, 0.0);
    float xr, xg, xb;
    float wr, wg, wb;
    float totalWr = 0.0;
    float totalWg = 0.0;
    float totalWb = 0.0;
    
    if (se_pass == 0) {
        refPos.y = uvPos.y;
        for (int i = 0; i < iWidth; ++i) {
            for (int isub = 0; isub < 8; ++isub) {
                refPos.x = float(i) + 0.1250 * float(isub) + 0.0625;
                rgbReference = texture2DRect(se_rgbaTex, refPos).xyz;
                
                xr = dotPitch * abs(refPos.x - uvPos.x);
                xr /= sr;
                wr = normalDistribution(xr);
                totalWr += wr;
                
                xg = dotPitch * abs(refPos.x - uvPos.x);
                xg /= sg;
                wg = normalDistribution(xg);
                totalWg += wg;
                
                xb = dotPitch * abs(refPos.x - uvPos.x);
                xb /= sb;
                wb = normalDistribution(xb);
                totalWb += wb;
                
                rgbDestination = vec3(
                    rgbDestination.x + wr * rgbReference.x,
                    rgbDestination.y + wg * rgbReference.y,
                    rgbDestination.z + wb * rgbReference.z
                );
            }
        }
        rgbDestination.x /= totalWr;
        rgbDestination.y /= totalWg;
        rgbDestination.z /= totalWb;
    } else {
        refPos.x = uvPos.x;
        for (int j = 0; j < iHeight; ++j) {
            for (int jsub = 0; jsub < 8; ++jsub) {
                refPos.y = float(j) + 0.1250 * float(jsub) + 0.0625;
                rgbReference = texture2DRect(se_rgbaPassTex, refPos).xyz;
                
                xr = dotPitch * abs(refPos.y - uvPos.y);
                xr /= sr;
                wr = normalDistribution(xr);
                totalWr += wr;
                
                xg = dotPitch * abs(refPos.y - uvPos.y);
                xg /= sg;
                wg = normalDistribution(xg);
                totalWg += wg;
                
                xb = dotPitch * abs(refPos.y - uvPos.y);
                xb /= sb;
                wb = normalDistribution(xb);
                totalWb += wb;
                
                rgbDestination = vec3(
                    rgbDestination.x + wr * rgbReference.x,
                    rgbDestination.y + wg * rgbReference.y,
                    rgbDestination.z + wb * rgbReference.z
                );
            }
        }
        rgbDestination.x /= totalWr;
        rgbDestination.y /= totalWg;
        rgbDestination.z /= totalWb; 
    }
    gl_FragColor = vec4(
        rgbDestination.x,
        rgbDestination.y,
        rgbDestination.z,
        texture2DRect(se_rgbaTex, uvPos).w
    );
    return;
}
