/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * exposure tonemapping
 * @brief g[}bsOtB^
 * 
 * Reference ::
 * Hugo Elias. "Exposure". Ref.2016-02-21.
 * http://freespace.virgin.net/hugo.elias/graphics/x_posure.htm
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
#extension GL_ARB_texture_rectangle: enable

// Screen Efects󂯎
uniform sampler2DRect se_rgbaTex;    // RGBA

// jARGBPx
float linearRGBtoY(const vec3 v) {
  return 0.299 * v.r + 0.587 * v.g + 0.114 * v.b;
}

/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * main
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
void main(void) {
    vec2 uvPos = gl_FragCoord.xy;
    vec4 rgba = texture2DRect(se_rgbaTex, uvPos).xyzw;
    
    float y0 = linearRGBtoY(rgba.rgb);
    float y1 = 1.0 - exp(-y0);
    float w = y1/y0;
    
    gl_FragColor = vec4(w * rgba.x, w * rgba.y, w * rgba.z, rgba.w);
    return;
}
