/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * thermal noise
 * @brief MmCYtB^
 * 
 * @param ISO ISOl
 * @param t I(sec)
 * 
 * ISOlCԘIsƂ̃ZT[̔MmCYV~[g܂D
 *
 * Reference ::
 * CASPAR003DgShade 3D PBRhD2015-12-31Dpp.53--54D
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
#extension GL_ARB_texture_rectangle: enable

// Screen Efects󂯎
uniform sampler2DRect se_rgbaTex;    // RGBA

//: name="ISO" type="float" value=100.0
uniform float ISO;

//: name="t (s)" type="float" value=0.01
uniform float t;

// 
// 
// @param[in] p vec2 ̌ɂȂCӃxNgDʏgl_FragCoord.xynD
// @return [0, 1)̗
//
// Reference ::
// shimacpyonDg_ȒlԂ֐ on GLSLhDRef.2016-02-21D
// URL: http://qiita.com/shimacpyon/items/d15dee44a0b8b3883f76
float rand(const vec2 p){
    return fract(sin(dot(p.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

// Kz
// 
// @param[in] p vec2 ̌ɂȂCӃxNgD
// @param[in] mu float ϒlD
// @param[in] sig float W΍
// @return muCW΍sig̐Kz
//
// p1Cp2͈قȂ2_wD
float SDNoise(vec2 p, float mu, float sig) {
    float x = rand(vec2(p.x, p.y - 0.25));
    float y = rand(vec2(p.x, p.y + 0.25));
    float z = sqrt(-2.0 * log(x)) * cos(2.0 * 3.141593 * y);
    z = clamp(z, -2.0, 2.0);
    z = z * sig;
    z = z + mu;
    return z;
    // Note::
    // Xɑ傫orȒlo邱Ƃ̂2Ђ艓Tv̓Nv悤ɂD
}

/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * main
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
void main(void) {
    vec2 uvPos = gl_FragCoord.xy;
    vec4 rgba = texture2DRect(se_rgbaTex, uvPos).xyzw;
    
    float u = ISO * t;
    float v = sqrt(u);
    
    vec3 noise = vec3(
        SDNoise(vec2(uvPos.x - 0.25, uvPos.y), 5.887e-09 * u, 1.488e-4 * v),
        SDNoise(vec2(uvPos.x       , uvPos.y), 9.473e-10 * u, 7.586e-5 * v),
        SDNoise(vec2(uvPos.x + 0.25, uvPos.y), 2.532e-09 * u, 1.046e-4 * v)
    );
    
    gl_FragColor = vec4(
        rgba.x + max(noise.x, 0.0),
        rgba.y + max(noise.y, 0.0),
        rgba.z + max(noise.z, 0.0),
        rgba.w
    );
    
    return;
}
