/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * diffraction 7diaphragm
 * @brief ܌tB^ip`j
 * 
 * @param F Fl
 *
 * ܂ɂu[ʂV~[g܂D
 * i`͎p`łD
 * 
 * Reference ::
 * Kakimoto M., Matsuoka K., Nishita T., Naemura T., Harashima H.
 * "Glare generation based on wave optics".
 * Computer Graphics Forum, Vol. 24, No. 2. pp.185--193, 2005-7.
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
#extension GL_ARB_texture_rectangle: enable

// Screen Efects󂯎
uniform sampler2DRect se_rgbaTex;    // RGBA
uniform vec2 se_screenSize;
uniform float se_cameraZoom;
uniform float se_cameraFocus; 

/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * main
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
void main(void) {
    vec2 uvPos = gl_FragCoord.xy;
    vec2 pos;
    vec4 rgba = texture2DRect(se_rgbaTex, uvPos).xyzw;
    vec3 rgb = vec3(0.0, 0.0, 0.0);
    
    // Fl
    float FValue = 1.0e+9;
    if (se_cameraFocus != 0.0) {
        FValue = 2.0 * 36.0 * (0.001 * se_cameraZoom) * (0.001 * se_cameraZoom)
                 / se_cameraFocus;
    }
    if (FValue > 512.0) {
        FValue = 512.0;
    }
    
    float pixWidth = max(se_screenSize.x, se_screenSize.y);
    float dotPitch = 0.036 / pixWidth;
    float airyRadius = 1.2196 * 435.8e-9 * FValue;
    float airyZeroPoint = 4.61089134947891;    
    float scalingFactor = airyRadius / airyZeroPoint / dotPitch;    // J[lԂ1pxXN[ŉpxɑ邩
    
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  4.56881e-06,  4.39653e-06,  2.94944e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  3.33421e-06,  2.15473e-06,  8.71458e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.88096e-07,  2.16627e-07,  1.32937e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  9.59153e-08,  1.64975e-07,  1.39001e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.05246e-07,  1.63703e-07,    8.267e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.37154e-07,  1.02124e-07,  2.56511e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  5.91874e-08,  9.55328e-08,  1.21917e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.01613e-07,  1.34222e-07,  9.83003e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.84697e-07,  1.39746e-07,   3.3246e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  4.87911e-07,  3.41759e-07,   4.1754e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.25832e-05,  8.78837e-06,  5.40786e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.17288e-06,    4.406e-07,  2.07274e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.15487e-07,  1.73549e-06,  2.30036e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.04587e-07,  1.79628e-07,  4.61303e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.30005e-07,  1.52102e-07,  2.26199e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.31259e-07,  1.60548e-07,  8.47137e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  6.91014e-07,  4.60211e-07,  2.60867e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.31516e-05,  9.43142e-06,  5.99571e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(   4.3975e-07,  3.08763e-07,  1.78066e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.55367e-07,  8.22316e-08,  1.55261e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.09231e-07,  5.29016e-08,  2.76463e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  9.58208e-08,  5.68011e-08,  1.82342e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.65079e-07,  1.29294e-07,  1.22938e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  4.23488e-07,  9.48141e-07,  9.25096e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  4.35959e-06,   2.6457e-06,  1.49165e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  6.66156e-06,  5.49684e-06,  2.80425e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  3.68401e-07,  1.72581e-07,  1.13603e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  7.75624e-07,  6.85153e-08,  5.13519e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  6.08389e-08,  3.43453e-08,  1.14836e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  3.21663e-08,  2.42188e-08,  1.11938e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.60172e-08,  1.89757e-08,  4.51715e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.92379e-07,  2.34182e-07,  4.64383e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  5.65725e-06,  4.22899e-06,  2.97237e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  3.83665e-06,  2.37546e-06,  1.26758e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.30999e-07,  1.13399e-07,  1.70428e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  9.14367e-08,  9.84086e-08,  2.28186e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.46527e-07,  7.82074e-08,  1.89243e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.04797e-07,  3.72761e-08,  3.57593e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.01996e-07,  9.35217e-08,  4.43548e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.26378e-07,  1.15031e-07,  1.64218e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  4.34509e-07,  2.48931e-07,   1.9855e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.20444e-05,  8.99763e-06,    5.883e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  3.82745e-06,  2.39731e-06,  9.45297e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.47296e-07,  1.46451e-06,  1.82689e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.79842e-07,  1.69707e-07,  3.45827e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.57646e-07,  1.46868e-07,  1.96804e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.54966e-07,  1.92967e-07,  1.13328e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.76646e-06,  1.12318e-06,  5.89945e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.47139e-05,  1.11205e-05,   6.8299e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  5.05775e-07,  2.96888e-07,  1.96813e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.23675e-07,   1.0069e-07,  9.14547e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.25813e-07,  7.12127e-08,  3.01445e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.29145e-07,  8.74035e-08,  2.96216e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.96122e-07,  1.49456e-07,  1.65484e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  8.89841e-07,  7.88523e-07,   2.9601e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.15164e-05,  9.28324e-06,  4.88817e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.02386e-06,   6.4833e-07,  2.94061e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  5.16035e-07,  1.02372e-07,   1.5269e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  9.79526e-07,  6.17118e-08,  1.13908e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.25577e-07,  3.43112e-08,  1.39211e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  4.24365e-08,   3.4559e-08,  1.54272e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  4.23439e-08,  4.02665e-08,  1.67287e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.02696e-07,  9.86809e-08,  1.38077e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.60984e-07,  2.09476e-07,  3.57883e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  7.03746e-06,  5.36292e-06,  3.76898e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.68914e-06,  2.81821e-06,  2.74994e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.82621e-07,  1.54784e-07,  1.21634e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.54127e-07,  1.22954e-07,  9.30948e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.95407e-07,  1.00305e-07,  4.07656e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.20998e-07,    1.006e-07,  9.46237e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.61044e-07,  1.02237e-07,  7.98774e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.62424e-07,  1.84128e-07,    1.956e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  6.10057e-06,   3.4346e-06,  2.29312e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.27297e-05,  1.05657e-05,  6.83243e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  6.11105e-07,  1.35229e-06,  3.40682e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.01562e-07,  1.45396e-07,  3.01358e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.07813e-07,  1.46754e-07,  2.31125e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.87899e-07,  2.61761e-07,  2.16882e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   4.4802e-06,  3.34186e-06,  2.70314e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   1.5101e-05,  1.15105e-05,  7.41706e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.87643e-07,  3.48544e-07,  2.32764e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.69605e-07,   2.7202e-07,  1.45186e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.46919e-07,  2.45127e-07,  2.23771e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   2.0728e-07,  1.64614e-07,  2.50518e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.75267e-07,  3.58518e-07,  3.54086e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  9.17154e-06,  7.96986e-06,  4.98238e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  6.17432e-06,  4.28384e-06,  2.35211e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.27218e-07,  1.86107e-07,  1.04491e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  1.57673e-07,  7.58916e-08,  6.05301e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  5.89004e-07,  4.26714e-08,   3.9852e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  6.44669e-07,  3.97388e-08,  9.00827e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  5.12628e-07,  4.10702e-08,  5.31474e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.45749e-07,   5.0109e-08,  6.60052e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  7.19635e-08,  6.19457e-08,  1.09162e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.43295e-07,  8.46236e-08,  2.89952e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.94677e-07,  2.38747e-07,  5.43919e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.02331e-05,  6.82388e-06,  6.23302e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.70446e-06,  3.56469e-06,  2.68191e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.97491e-07,  2.07285e-07,  3.09229e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.99138e-07,  1.51389e-07,  2.46314e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.43772e-07,  1.98056e-07,  1.50498e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.28075e-07,  1.05609e-07,  1.84812e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.54095e-07,  2.14285e-07,  2.57293e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.57254e-06,  6.29021e-07,  4.64887e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.31687e-05,  1.62988e-05,  1.03119e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.24262e-06,   1.3036e-06,  7.83604e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.24491e-07,   1.8908e-07,  2.15935e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(   2.7433e-07,  2.09923e-07,  2.02034e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.74919e-07,  3.22674e-07,  2.21953e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.08126e-05,  8.19888e-06,  6.49844e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.56909e-05,  1.01831e-05,  5.18373e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.52919e-07,  3.04454e-07,  1.52904e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(   2.9402e-07,  1.64079e-07,   7.7638e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.32348e-07,  2.14188e-07,  1.37983e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.62304e-07,  4.39892e-07,   9.8181e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.40824e-06,  4.43563e-06,  3.10559e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.52947e-05,  1.00222e-05,  6.71281e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  7.40433e-07,  9.79227e-07,  1.90988e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.99487e-07,  4.90997e-07,  6.58546e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.48003e-07,  6.43885e-08,  3.98836e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.65091e-07,  4.06962e-08,   3.7471e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.60332e-07,     3.92e-08,  7.40362e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  1.51998e-07,  4.01038e-08,  5.98943e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.09605e-07,  3.91613e-08,  4.74555e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.44166e-08,  6.57689e-08,   1.9037e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  8.87594e-08,  7.33395e-08,  1.40187e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.55664e-07,  1.31322e-07,  2.87206e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  6.83769e-07,  3.68101e-07,  7.59608e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.12202e-05,  8.90518e-06,  6.08656e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  6.83202e-06,  4.30725e-06,  2.48419e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.81029e-07,  2.27798e-07,   1.7019e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.41996e-07,  2.52704e-07,  1.48886e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(   3.3474e-07,  1.77333e-07,  7.21072e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.87075e-07,  2.00937e-07,  1.74384e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(   1.0853e-06,  4.64968e-07,  2.82654e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(   1.9551e-05,  1.67231e-05,  1.17731e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  8.04974e-06,  5.19461e-06,  3.68092e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.71037e-07,  3.76023e-07,  1.37624e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  3.87171e-07,  2.60468e-07,  2.65333e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  8.06688e-07,  4.04249e-07,  4.00376e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.78749e-05,  1.55473e-05,   1.3015e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.15427e-05,  7.12307e-06,  2.94989e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(   4.6598e-07,  3.44715e-07,  1.69597e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  3.64185e-07,  1.99973e-07,  1.26995e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.61603e-07,  2.68569e-07,  1.78071e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.62623e-06,  1.00643e-06,  4.53011e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.00547e-05,  1.59265e-05,  1.28471e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.49093e-06,  1.49322e-06,  7.09333e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.92296e-07,  7.37128e-07,  1.30343e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.57381e-07,  1.28529e-06,   5.7137e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  9.95505e-08,    2.834e-07,  5.56159e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.12834e-07,  9.47061e-08,  6.40718e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.21187e-07,  5.85779e-08,  1.06603e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  1.70884e-07,  6.06701e-08,  7.07099e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.13498e-07,  8.29528e-08,   9.1682e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  6.83475e-08,  5.37426e-08,  3.04604e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  5.46668e-08,   5.7649e-08,  1.81238e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.30788e-07,  6.32052e-08,   5.6124e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  2.24881e-07,   1.3425e-07,  1.09257e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.68419e-07,  5.00465e-07,  2.88456e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.44718e-05,  1.18419e-05,  7.50799e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.08658e-06,  5.37486e-06,  3.13985e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  5.08237e-07,  4.44828e-07,  1.79784e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  3.03794e-07,  2.98588e-07,     1.99e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.52653e-07,  2.99288e-07,  1.36748e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.62098e-07,  4.16161e-07,  2.39445e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.71052e-06,  6.63182e-06,  3.25837e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(   2.5378e-05,  2.12348e-05,  1.57861e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.37372e-06,  6.82041e-07,  7.14508e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.40667e-07,  3.62477e-07,  2.59997e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.39826e-06,  6.26278e-07,  3.90085e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  2.80773e-05,  2.50177e-05,  1.82382e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.16571e-06,  3.89252e-06,  1.14644e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  6.22164e-07,  4.01713e-07,  4.26568e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.61173e-07,  2.85659e-07,  3.96733e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  9.52897e-07,  6.27815e-07,  4.75042e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.70714e-05,  1.46822e-05,  8.52894e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.17441e-05,  8.02289e-06,  7.39058e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  6.29526e-07,  3.90792e-07,    1.982e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  2.53565e-07,  2.19421e-07,  9.08623e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.62705e-07,  8.00926e-07,   5.7493e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(   1.4438e-07,  5.88933e-07,  7.06222e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.71407e-07,  8.82293e-07,   6.7309e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  3.11069e-07,  9.31255e-07,  8.80696e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.84819e-07,  3.30968e-07,  9.43172e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.88828e-06,  1.45454e-06,  5.92302e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.01555e-07,  6.14723e-08,  5.70267e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.20757e-07,  5.63335e-08,  7.84259e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.08765e-07,  6.40725e-08,  1.31504e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.27813e-07,  7.46234e-08,   8.3039e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  3.36715e-07,  1.86998e-07,   1.1997e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.40407e-06,  7.10991e-07,  3.48788e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.21384e-05,  1.37486e-05,  1.12805e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.04937e-05,  6.87442e-06,  4.12914e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   8.7439e-07,  4.72342e-07,  3.23332e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  5.51484e-07,  3.57629e-07,  3.03948e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.14103e-06,  4.91621e-07,  2.92986e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.09873e-06,  1.53184e-06,  7.89043e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  4.40079e-05,  3.01005e-05,  2.51679e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  3.37897e-06,  1.38581e-06,  1.05167e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   1.1011e-06,  5.14496e-07,  3.85574e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(    1.839e-06,  1.11208e-06,  6.51408e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  4.53018e-05,  3.16301e-05,  2.56325e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   5.1615e-06,  1.81931e-06,  9.90962e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.04278e-06,   4.9452e-07,  3.28002e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  9.27171e-07,  5.25455e-07,  3.58393e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.09068e-05,  5.10357e-06,  4.06349e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   3.0164e-05,  2.18102e-05,  1.73145e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.34368e-06,  6.97761e-07,  1.81852e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  4.37546e-07,  2.45999e-07,  6.63879e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.74694e-07,  1.57625e-07,  9.65644e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.30405e-07,  3.94319e-07,  7.78955e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.55493e-07,  3.79657e-07,  7.30605e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  4.43599e-07,  3.10613e-07,  1.05271e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.47713e-06,  9.24373e-07,  2.54443e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  9.03649e-06,  7.02566e-06,  3.43646e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  9.09932e-06,  7.70624e-06,  3.86391e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  9.01464e-08,  1.09006e-07,  5.81918e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  9.51878e-08,  7.43758e-08,   2.0539e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.02354e-07,  8.90193e-08,  2.00095e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.14446e-07,  1.03866e-07,  1.16589e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.89178e-07,  1.20706e-07,  1.06909e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  3.40049e-07,  2.73265e-07,  1.50207e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.87592e-06,  9.80126e-07,  5.29223e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.55619e-05,  2.11024e-05,  1.46069e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.30571e-05,  8.58723e-06,  5.63959e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.16639e-06,  6.89288e-07,  4.11189e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  9.84508e-07,  6.17305e-07,  4.25243e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.95222e-06,  1.44423e-06,  5.82445e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  3.61775e-05,  3.47269e-05,  2.65061e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.07266e-05,  1.00665e-05,  5.68683e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.79194e-06,  1.00296e-06,  5.25745e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.46799e-06,  1.93984e-06,  1.24643e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  5.60792e-05,  4.45353e-05,   3.1982e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.99924e-06,  1.95913e-06,  1.13419e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.35665e-06,  7.86847e-07,  4.11776e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.41752e-06,  1.49475e-06,  8.54408e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  4.28564e-05,  3.28662e-05,  2.39473e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(   5.2528e-06,  4.79485e-06,  2.34679e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(   6.1379e-07,  4.48338e-07,  4.80397e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  4.18389e-07,   2.7163e-07,  1.64183e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  3.92322e-07,  2.13232e-07,  1.04796e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  4.04382e-07,  3.24162e-07,  8.96557e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  7.71271e-07,  8.58359e-07,  3.18986e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  7.88375e-06,  4.34757e-06,  2.19159e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(   1.3663e-05,  1.04492e-05,  6.80869e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  4.58507e-06,  3.50106e-06,  2.04883e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  3.87971e-07,  1.99997e-07,  2.64205e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.43708e-07,  2.40581e-07,  3.79081e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.93529e-07,  1.95583e-07,  1.56453e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.73789e-07,  1.80399e-07,  1.45904e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.33811e-07,  1.54714e-07,  1.48739e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.34034e-07,  1.68821e-07,  1.02346e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.98046e-07,  2.16187e-07,  1.11127e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  5.64804e-07,  3.79009e-07,  2.15251e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.57715e-06,  1.61911e-06,  8.28214e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.48198e-05,  2.95691e-05,   2.2637e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.67469e-05,  1.17666e-05,  7.70209e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.89961e-06,  1.17866e-06,  6.85977e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.53513e-06,  1.47031e-06,  8.52474e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.52778e-05,  1.43221e-05,  9.69078e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  6.03145e-05,  4.63923e-05,  3.69993e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.58895e-06,  2.06579e-06,  1.17202e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  4.87294e-06,  2.73545e-06,  2.14378e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  7.42342e-05,  6.10608e-05,  4.69727e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(   3.6635e-06,  2.62593e-06,  1.26229e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.62676e-06,  1.70173e-06,   1.0434e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.10698e-05,  2.61721e-05,  1.99696e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.37364e-05,   2.5855e-05,  1.93056e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.53696e-06,  9.56813e-07,  5.44354e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  6.02867e-07,  4.42845e-07,  3.13014e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  6.08916e-07,  4.08067e-07,  8.89713e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  9.53869e-07,   5.0776e-07,  5.33313e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  4.15207e-06,  2.26631e-06,  2.22041e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(   1.7936e-05,  1.41915e-05,  1.20356e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.30862e-05,  1.00886e-05,  8.76162e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.13812e-06,  7.88455e-07,  2.43667e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  4.06294e-07,  1.65407e-07,  4.56338e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.99924e-07,  8.21525e-08,  3.55355e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.07965e-06,  4.17865e-06,  2.25084e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   1.0253e-06,  6.62171e-07,  3.42991e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   5.4254e-07,  3.71307e-07,  1.88665e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.65019e-07,   2.3942e-07,  2.19023e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.62257e-07,  2.19878e-07,  1.61894e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.77852e-07,  2.34059e-07,  1.55597e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.59918e-07,  2.27595e-07,  2.07027e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  8.07369e-07,  5.08423e-07,  3.40375e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.88343e-06,  2.41106e-06,  1.37706e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.96528e-05,  4.25463e-05,  3.12083e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.22641e-05,  1.60588e-05,  1.06476e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.98291e-06,  2.13309e-06,  1.01825e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.19987e-06,  3.68862e-06,  2.82121e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  9.81236e-05,  8.01958e-05,  5.86706e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  6.43573e-06,  4.82213e-06,  3.06966e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  1.45667e-05,  7.03012e-06,  3.86899e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  9.60512e-05,  8.19266e-05,  6.14101e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.55895e-06,  3.47486e-06,  1.68588e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   1.4296e-05,  9.86338e-06,   6.5191e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  7.52328e-05,  6.35608e-05,  4.63197e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.65518e-06,  2.51276e-06,  1.40431e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  1.18598e-06,  8.56848e-07,  4.99963e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  1.08443e-06,  7.73953e-07,  4.69061e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.01969e-06,  1.56342e-06,  9.40885e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  1.97141e-05,  1.42927e-05,  1.09876e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.49901e-05,  2.04317e-05,  1.32815e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.67851e-06,  4.41306e-06,  1.87942e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  6.63515e-07,  5.52462e-07,  1.87636e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.67168e-07,  2.04358e-07,  1.02474e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  1.52908e-07,  1.19774e-07,    3.032e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.23194e-07,  1.31653e-07,  4.32578e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.79706e-06,  5.02039e-06,  3.61395e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.40296e-05,   1.0491e-05,  6.41116e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.53906e-05,  1.15184e-05,  7.93874e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  9.61457e-06,  4.93507e-06,  3.15399e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.69032e-06,   8.4759e-07,  6.35229e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(   1.1692e-06,  5.50028e-07,  3.89567e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(   8.6278e-07,  4.64594e-07,   3.0355e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.16326e-06,   4.8986e-07,  3.10781e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(   1.8044e-06,  8.36826e-07,  4.96455e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.67042e-06,  4.01818e-06,  2.23166e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  8.54004e-05,  6.53019e-05,   5.2551e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  3.57156e-05,   2.3111e-05,  1.57042e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.96409e-06,  4.65108e-06,   3.0835e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000122679,  9.44449e-05,   7.2885e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  5.17423e-05,  3.37389e-05,  2.71326e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  5.02308e-05,  2.66503e-05,  1.86516e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000133653,  0.000109425,  8.68164e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.36773e-05,  6.61347e-06,  4.28223e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000115919,  9.04783e-05,  7.35278e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  2.90596e-05,  1.88417e-05,  1.11598e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  3.55311e-06,  1.73127e-06,  1.21892e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  3.02227e-06,  1.89743e-06,    1.148e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.94537e-05,  1.34955e-05,  9.61132e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  4.37941e-05,  3.47708e-05,  2.51321e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  2.17301e-05,  1.31006e-05,  1.09727e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.52181e-06,  1.02353e-06,  4.91355e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  5.90345e-07,  3.77397e-07,   1.8717e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  3.36524e-07,  3.64306e-07,  1.79261e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  2.22363e-07,  1.19515e-07,  1.51563e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.35075e-07,   7.5658e-08,  2.90377e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  1.94102e-07,  8.12257e-08,  3.95877e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  9.99919e-07,  2.17773e-07,  1.88258e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.21701e-06,  4.05616e-07,  2.04601e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  3.36864e-06,  2.17937e-06,   1.1275e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.50737e-05,   1.1982e-05,  7.63633e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   2.5498e-05,  1.97243e-05,  1.39054e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  2.45824e-05,  1.97215e-05,  1.32125e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.13336e-05,  6.13356e-06,  3.16542e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  2.06522e-06,  1.71441e-06,  8.37161e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  2.00746e-06,  1.51577e-06,  7.03584e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  2.28105e-06,  2.03818e-06,  9.29517e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.03151e-05,  8.37664e-06,  4.32345e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000121601,  0.000106841,   8.1598e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  5.63355e-05,    4.066e-05,  2.52895e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  6.47584e-05,  4.53054e-05,  2.13981e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000193343,  0.000166464,  0.000132091) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000122413,  8.95868e-05,   7.2367e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000149313,  0.000133775,  9.17267e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000113001,  7.88846e-05,  5.67082e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   0.00011045,  0.000102125,  7.64808e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  7.42673e-06,  5.13313e-06,  2.47255e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.64635e-05,  9.11763e-06,  4.84961e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  6.45664e-05,  5.47908e-05,  3.85387e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  4.67114e-05,  3.89356e-05,  3.01218e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  5.58613e-06,  3.42984e-06,  1.80493e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.31608e-06,  6.66742e-07,  6.81641e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  5.05801e-07,  3.69453e-07,  2.51479e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  3.15845e-07,  2.47835e-07,  1.57981e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  2.43975e-07,  2.87129e-07,  1.19217e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  2.21536e-07,  1.49203e-07,  1.15611e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.80173e-07,  1.08636e-07,  1.41782e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  1.46525e-07,  1.11453e-07,  6.60209e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  2.62763e-07,  1.52909e-06,   2.2694e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  2.20173e-07,  1.58044e-06,  1.25979e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  2.57929e-07,  1.51653e-06,  2.11131e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  7.19538e-07,   1.4411e-06,  3.82636e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  1.16624e-06,  1.86302e-06,  6.35453e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  8.68497e-06,   7.2408e-06,  4.67369e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  3.50038e-05,  2.56901e-05,  2.17293e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  4.98566e-05,  4.12397e-05,  2.99281e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  4.13258e-05,  3.84958e-05,   2.9578e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  1.43892e-05,  1.02607e-05,  5.46562e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(    6.799e-06,  4.63185e-06,  3.49632e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  1.99485e-05,  1.41697e-05,  9.93157e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000222049,  0.000199487,  0.000166659) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000116797,  8.36757e-05,  5.71521e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000427763,  0.000369188,  0.000289671) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000342398,  0.000282398,  0.000240398) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000217568,  0.000171571,  0.000109139) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000351334,  0.000299763,  0.000235035) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  2.96517e-05,  2.10624e-05,  1.21539e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  8.58386e-05,  7.81147e-05,  5.61939e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000126634,  0.000100015,  8.03969e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(    2.684e-05,  2.02213e-05,  1.53071e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  2.92168e-06,  1.96979e-06,  1.28605e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  1.23859e-06,  8.54756e-07,  5.55431e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  8.62316e-07,  5.12107e-07,     4.12e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  6.53786e-07,  4.00899e-07,  3.14517e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  5.06448e-07,  2.99988e-07,  2.17493e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  4.32109e-07,  3.23466e-07,  1.99972e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(   2.8116e-07,  3.19905e-07,  2.51931e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  2.64642e-07,  2.50091e-07,  1.11083e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  3.09133e-07,  1.99835e-07,  1.60011e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  8.14922e-08,  5.37151e-07,  4.60657e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  1.23683e-07,  2.12117e-07,  3.80389e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  2.09374e-07,  1.06927e-07,  3.30384e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  2.96187e-07,  1.45417e-07,  2.48841e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  4.94287e-07,  2.34675e-07,    2.206e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  6.80376e-07,    4.578e-07,  1.72163e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  1.76778e-06,  8.19362e-07,  1.68408e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  4.45468e-06,  2.07424e-06,  1.92972e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  3.11922e-05,  2.02646e-05,  1.64684e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  8.53585e-05,   7.1287e-05,  5.46151e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00014672,  0.000112178,  8.77022e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000129982,  9.75858e-05,  5.89861e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  8.43679e-05,  5.03972e-05,  2.65083e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00064382,   0.00050083,   0.00037471) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00105972,  0.000834993,  0.000615017) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00150679,   0.00115446,  0.000865301) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00107581,  0.000824718,  0.000566222) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000440718,  0.000269806,  0.000143235) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000344429,  0.000292055,  0.000227607) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000140963,  0.000106564,  7.80434e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  1.58698e-05,  7.28045e-06,  4.56745e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  5.67926e-06,  2.94775e-06,  1.73975e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   4.0034e-06,  2.16312e-06,    1.092e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  2.44482e-06,  1.79596e-06,  7.54453e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  2.15372e-06,  1.31488e-06,  8.28893e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  2.19059e-06,  1.18878e-06,  9.44243e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  3.47515e-06,  1.46057e-06,   7.4311e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  6.03951e-06,  2.61754e-06,   8.9151e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  7.50757e-06,  4.70192e-06,  1.77797e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  9.04842e-06,  6.35959e-06,   3.0071e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  9.95955e-06,  7.59064e-06,  4.23094e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  1.06814e-07,  3.56724e-08,  7.57585e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   1.5104e-07,  8.50652e-08,  1.59143e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   1.8999e-07,  1.08484e-07,  8.52736e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  2.67386e-07,  1.56027e-07,   7.1697e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  4.02379e-07,  2.55649e-07,  1.41021e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  6.65258e-07,  3.78289e-07,  1.43723e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  1.08461e-06,   5.0276e-07,  2.93144e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  1.47101e-06,  9.25737e-07,  5.90824e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  2.30216e-06,  1.78046e-06,  1.01761e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  4.87769e-06,    3.559e-06,  2.02937e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  1.71115e-05,  1.10706e-05,  8.06422e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000114409,  0.000101484,  8.96619e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00038262,  0.000334259,  0.000273458) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00102214,  0.000808388,  0.000600984) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00457878,   0.00393079,   0.00282049) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(    0.0186714,    0.0132868,    0.0108455) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(    0.0055199,    0.0044385,   0.00323617) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00108254,  0.000831113,  0.000578978) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000199071,  0.000151257,  9.01195e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000119991,  0.000100924,  6.23951e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000111033,  9.04871e-05,  6.68324e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  8.35964e-05,  7.44782e-05,  5.55232e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  6.96751e-05,  5.98843e-05,    4.684e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  5.56871e-05,  4.51179e-05,  3.26108e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  4.90228e-05,  3.23963e-05,  2.60198e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  3.42812e-05,  2.77542e-05,  1.89483e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  2.61965e-05,  2.14435e-05,  1.56561e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  2.04061e-05,   1.6114e-05,  1.13228e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  1.24102e-05,  1.07047e-05,  8.45576e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  7.84178e-06,  6.21198e-06,   4.6635e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  4.43235e-06,  2.84942e-06,  2.37067e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   2.0306e-07,  1.05624e-07,  1.03049e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  3.96795e-07,  1.47389e-07,  5.94375e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  6.30928e-07,  2.38612e-07,  7.89505e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  9.44102e-07,  3.96124e-07,  1.25455e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  9.74896e-07,  7.60955e-07,  3.01091e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  1.28876e-06,  1.05197e-06,  5.95873e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  2.97244e-06,  1.28344e-06,  1.01696e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  7.35128e-06,  2.81984e-06,  1.47817e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  1.73124e-05,  8.43201e-06,  4.91331e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  4.03207e-05,  2.53214e-05,  1.67979e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  9.30726e-05,  6.27898e-05,  5.33542e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00018267,  0.000147535,  0.000117115) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000362977,  0.000326242,  0.000281305) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00130514,  0.000993139,  0.000719452) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(    0.0108731,    0.0108347,   0.00758287) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(     0.889269,     0.910013,     0.932074) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(    0.0186919,    0.0132754,    0.0107991) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00148106,   0.00113606,  0.000838334) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000376058,  0.000317978,  0.000272505) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000151199,  0.000121969,  0.000104158) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  7.44627e-05,  4.80671e-05,  3.96754e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  2.79035e-05,   1.5859e-05,  1.07835e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  1.07716e-05,  5.15377e-06,  3.00495e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  4.02837e-06,  2.04922e-06,  1.38373e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  2.05219e-06,  1.28852e-06,  1.00995e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  1.30464e-06,   1.0637e-06,  4.91648e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  1.02015e-06,  6.32535e-07,  2.62945e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  9.30427e-07,  3.26033e-07,  1.24124e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   5.1801e-07,  2.11175e-07,  7.41717e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  3.03517e-07,  1.59249e-07,  5.57888e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  1.59977e-07,  1.05172e-07,  9.64564e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  6.20147e-06,  4.16824e-06,  3.24366e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  1.01112e-05,   7.8966e-06,  5.56718e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  1.45493e-05,  1.21852e-05,  9.06104e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   2.2597e-05,  1.69109e-05,  1.13464e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  2.68299e-05,  2.15024e-05,  1.54186e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  3.44369e-05,  2.70603e-05,  1.86031e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  4.63725e-05,  3.17939e-05,  2.56416e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  5.21715e-05,  4.38459e-05,  3.21944e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  5.94569e-05,  5.44834e-05,  4.37268e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  6.87839e-05,  6.44392e-05,  4.83542e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  8.09569e-05,  6.79189e-05,  5.10679e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  8.47724e-05,  7.11144e-05,  4.10844e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000146021,   0.00011242,   7.1221e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000950817,  0.000729553,  0.000537811) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00358868,    0.0033327,    0.0027686) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(    0.0108572,    0.0108414,   0.00763948) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(    0.0045879,   0.00394772,   0.00281101) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00107408,  0.000840882,  0.000620812) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000424692,   0.00036432,  0.000286149) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00016526,  0.000140251,  0.000113742) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  3.14621e-05,  1.90172e-05,  1.36861e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  5.30678e-06,  4.27565e-06,  2.37055e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   2.9152e-06,  1.75194e-06,  1.12883e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  1.69235e-06,  9.37715e-07,  5.68485e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   1.0591e-06,  5.15932e-07,  2.96314e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  5.92026e-07,   3.7962e-07,  1.50569e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  3.58204e-07,  2.78773e-07,  1.39479e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  2.56822e-07,  1.49162e-07,  8.12648e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  2.23703e-07,  9.53288e-08,  9.57526e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  1.58268e-07,  8.57844e-08,   2.8158e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   1.0867e-07,  4.13142e-08,  1.23841e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  7.86788e-06,  6.08419e-06,  3.29299e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  6.54487e-06,  4.53204e-06,  2.01967e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  4.91248e-06,  2.94929e-06,  1.03832e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  3.46463e-06,  1.49073e-06,  6.65587e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  1.87397e-06,  9.83043e-07,  7.49814e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(    1.466e-06,  1.13633e-06,  8.48104e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  1.99131e-06,  1.25314e-06,   6.5035e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  2.41966e-06,  1.51631e-06,  6.68318e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  3.53027e-06,  1.77939e-06,  1.10286e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  5.15935e-06,  2.65623e-06,  1.64252e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  1.62616e-05,  7.84226e-06,   4.3819e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00013916,  0.000107269,  7.96411e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000311603,  0.000266678,  0.000212429) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00035257,  0.000218487,   0.00012304) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000934871,  0.000705831,  0.000512897) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(    0.0013127,  0.000998089,  0.000735849) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00101594,  0.000804382,  0.000600785) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000658324,  0.000512238,  0.000383837) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  9.46445e-05,  6.42808e-05,  3.85041e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  9.08021e-05,  6.81067e-05,  3.85401e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000140121,  0.000107747,  8.49001e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  9.51621e-05,   7.7733e-05,  5.78347e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  4.61495e-05,  3.14854e-05,  2.41504e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   9.2299e-06,  3.41082e-06,  2.55401e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(    1.997e-06,  1.04906e-06,  1.82364e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(    9.223e-07,  4.77893e-07,  1.82118e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  5.24278e-07,   2.5811e-07,   2.1655e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  3.24532e-07,  1.60609e-07,   2.4899e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  1.95804e-07,  1.49732e-07,  3.27731e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  1.33402e-07,  3.58056e-07,  3.62398e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   8.6885e-08,  7.57014e-07,  4.05768e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(   2.3005e-07,  1.99214e-07,  1.45089e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.19001e-07,  2.39905e-07,  1.02976e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.95755e-07,  2.82858e-07,  2.55242e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  4.28106e-07,  2.97896e-07,   1.9078e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  4.96019e-07,  2.86128e-07,  1.88029e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  5.64808e-07,  3.66026e-07,  2.79573e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  7.50626e-07,  4.99333e-07,  4.48845e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  1.18365e-06,  8.45687e-07,  5.41506e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.92893e-06,   1.9215e-06,  1.29202e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.87351e-05,  2.22811e-05,  1.65031e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000124046,  9.72024e-05,  7.88234e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  7.26874e-05,  6.80977e-05,  5.00104e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.18624e-05,  1.75224e-05,  1.06471e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000321438,  0.000276283,  0.000221293) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000157186,  0.000123554,   7.9403e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000335592,  0.000300497,  0.000258782) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000400279,  0.000343811,  0.000278815) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  8.34359e-05,  5.72632e-05,  3.70606e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000231927,  0.000205584,  0.000171735) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  3.56657e-05,  2.40673e-05,  1.64661e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  7.32838e-06,   4.5798e-06,  3.24054e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  7.04599e-06,  5.44471e-06,  3.84473e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.85318e-05,  2.90278e-05,  2.23504e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  4.69181e-05,  4.15065e-05,  3.00755e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(   4.1453e-05,  2.83608e-05,  2.33189e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  1.47579e-05,  1.21711e-05,  7.36022e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  2.27087e-06,  2.04199e-06,  7.60879e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  8.34853e-07,  1.63073e-06,  3.73832e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  3.24552e-07,  1.45605e-06,  2.06168e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  3.15439e-07,  1.45359e-06,  1.28976e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  3.68721e-07,  1.29336e-06,  2.22118e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.64757e-07,  1.04359e-07,  7.56935e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.68164e-07,  1.09341e-07,  1.34683e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.97733e-07,  1.33243e-07,   1.1966e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  2.21472e-07,  2.94498e-07,  1.29524e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  2.95894e-07,   2.2823e-07,  1.73039e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  5.36341e-07,  3.85469e-07,  2.30677e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.33738e-06,   6.8679e-07,  6.88157e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   6.3305e-06,  3.89358e-06,  2.06662e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  4.72774e-05,  3.96766e-05,  3.02816e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  5.90424e-05,  5.06844e-05,  3.61792e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.30715e-05,  7.46816e-06,  4.17195e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  6.99775e-06,  4.76679e-06,  2.33252e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  9.85237e-05,  9.10094e-05,  6.98539e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   0.00011286,  8.23992e-05,  5.93076e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000113564,   0.00010171,  6.77118e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000154723,  0.000116002,  8.83817e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000143681,  0.000131959,  0.000113718) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000102225,  7.08976e-05,  3.62891e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  3.04307e-05,  2.52356e-05,  1.56697e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000129627,  0.000110955,  8.49152e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.90654e-05,  1.47693e-05,  7.58073e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  2.77594e-06,  2.08877e-06,  9.86391e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.62767e-06,   1.2603e-06,  6.45512e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.91597e-06,  1.49606e-06,  7.33384e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  6.03171e-06,  3.19281e-06,  1.77259e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.91887e-05,  1.56411e-05,  1.07454e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  2.51505e-05,  2.00078e-05,  1.40861e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.99866e-05,   1.4336e-05,  9.04559e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  5.63511e-06,  3.91075e-06,   1.9848e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  1.43763e-06,  4.61681e-07,  2.44124e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  9.80384e-07,  2.58163e-07,  1.87492e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   2.0988e-07,  8.52567e-08,  6.52359e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.37114e-07,  8.37934e-08,  3.28216e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  2.20683e-07,  1.22173e-07,  1.44941e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  3.34971e-07,  3.69752e-07,  1.66848e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   6.0003e-07,  4.05286e-07,   1.7674e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.68223e-06,  1.06699e-06,  5.03873e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  2.31932e-05,  1.38406e-05,  1.14232e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  4.18198e-05,  3.37201e-05,  2.44573e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.65972e-05,  1.15639e-05,  8.36059e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  2.87853e-06,   1.8002e-06,   1.0688e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  3.14923e-06,  1.64157e-06,  1.16969e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  2.38892e-05,  1.63352e-05,  9.62532e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000115614,  8.97799e-05,  7.28615e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.24386e-05,  6.21115e-06,  3.96677e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000106622,  9.14702e-05,  7.48429e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   6.5923e-05,  3.76036e-05,  2.82435e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  2.83644e-05,  1.92842e-05,  1.57217e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000138555,    0.0001056,  8.13634e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  7.92843e-06,  4.55768e-06,  3.07069e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.98385e-05,  1.39426e-05,  9.51716e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  9.05267e-05,  6.86172e-05,  5.51642e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.36559e-05,  7.59289e-06,   3.9677e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  2.04829e-06,  9.10556e-07,  5.56191e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.07392e-06,  5.00782e-07,  2.95055e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   7.7407e-07,  4.17339e-07,  3.07408e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  9.14178e-07,  4.48622e-07,  3.57498e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   1.1483e-06,  7.31968e-07,  5.64316e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  5.57381e-06,  2.77577e-06,  1.93554e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.32743e-05,  9.99495e-06,  7.16004e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.45439e-05,  1.07564e-05,  6.51057e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  1.01102e-05,  6.64946e-06,  4.52208e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.13858e-07,  1.30562e-07,   4.1626e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  1.64428e-07,  1.15757e-07,  3.19782e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.65983e-07,   1.9297e-07,  1.48642e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  7.03777e-07,  4.86937e-07,  2.08922e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  6.36014e-06,  4.77648e-06,  2.06123e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.47452e-05,  2.03194e-05,  1.32265e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(   1.7555e-05,  1.28714e-05,  1.01645e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  1.68336e-06,  1.42264e-06,  9.73869e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  9.70073e-07,  7.14744e-07,  4.62923e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  1.13556e-06,  8.19468e-07,  4.61048e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.01268e-06,  2.27018e-06,  1.35821e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  7.08609e-05,  6.04347e-05,  4.44195e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  1.53216e-05,  1.10176e-05,  7.12698e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  5.73415e-06,  3.04801e-06,  1.63904e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  8.43317e-05,  7.69228e-05,  5.86352e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.27823e-05,  1.14583e-05,  5.77975e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.66526e-06,  4.07886e-06,  2.64987e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  9.35381e-05,  7.70668e-05,  5.71609e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  6.72162e-06,  5.06927e-06,  3.14235e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(   2.8281e-06,  1.86524e-06,  1.05853e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  1.29441e-05,   9.3768e-06,  6.50736e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  5.30892e-05,  4.55907e-05,  3.33088e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  7.63093e-06,  4.63421e-06,  2.48459e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  1.02594e-06,  5.51492e-07,  3.74649e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  5.42879e-07,  2.36765e-07,  1.88082e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.07323e-07,  2.29945e-07,  1.49484e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.01127e-07,  2.03757e-07,  1.52575e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.25962e-07,  2.22189e-07,  2.10057e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.69611e-07,  2.99912e-07,   1.7466e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  5.94547e-07,  4.70697e-07,   2.8551e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.93558e-06,  2.70149e-06,  1.45803e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.46743e-07,  8.77342e-08,  3.23632e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  4.52163e-07,  1.64009e-07,  3.62578e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.28777e-06,  9.02253e-07,   2.0511e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.37352e-05,  1.03678e-05,  8.82844e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.67481e-05,  1.35962e-05,  1.17106e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.34324e-06,  1.90995e-06,  2.22981e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  9.10756e-07,    4.721e-07,  5.09723e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  5.80578e-07,  3.72602e-07,  9.06683e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  6.10809e-07,  4.27398e-07,  3.13319e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.33458e-06,  8.81181e-07,  5.30619e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.00448e-05,  2.35097e-05,  1.77291e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.31017e-05,   2.7182e-05,  2.07288e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(   2.5132e-06,  1.65632e-06,  1.03566e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.35653e-06,   2.3034e-06,  1.08678e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  6.81466e-05,  5.82204e-05,  4.58464e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  7.66429e-06,  3.06777e-06,  2.10304e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.14162e-06,  1.96534e-06,  1.12553e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  4.72198e-05,  3.59891e-05,  3.03245e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(    2.617e-05,  2.31094e-05,  1.55778e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.58512e-06,  1.56517e-06,   8.4112e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.87108e-06,  9.60297e-07,  6.65992e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  9.17132e-06,  6.98528e-06,  4.69507e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.81834e-05,  3.18799e-05,  2.43398e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  5.15951e-06,   3.1892e-06,  1.47265e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  6.90251e-07,  3.99134e-07,   2.4933e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.08731e-07,  2.21876e-07,  1.09138e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.49895e-07,  1.78336e-07,  1.01048e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.11051e-07,  1.50742e-07,  1.39216e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.50214e-07,  1.74881e-07,  1.59349e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.89507e-07,  1.74441e-07,  1.49888e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.83359e-07,  2.37503e-07,  3.92955e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  4.07899e-07,  2.14435e-07,  2.81031e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  4.94047e-06,  3.86515e-06,  2.18793e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.34461e-05,  1.02098e-05,  6.69297e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  6.97809e-06,  3.80025e-06,  1.99143e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  6.94157e-07,  7.57544e-07,  2.42919e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.83525e-07,  3.34491e-07,  7.10138e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.55625e-07,  2.15904e-07,    1.047e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.81808e-07,  2.60236e-07,  1.63505e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  5.85369e-07,  4.36643e-07,  5.98262e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  4.51642e-06,   4.1353e-06,  2.00679e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  4.21876e-05,  3.24644e-05,  2.38606e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.76859e-06,  1.57079e-06,  8.44717e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.14787e-06,   8.0377e-07,  3.97411e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.46984e-06,  1.87863e-06,  9.49509e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  5.58314e-05,  4.41161e-05,  3.16156e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.90569e-06,  1.97179e-06,  1.33287e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.60394e-06,   8.5138e-07,  5.21298e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.13785e-05,  5.35755e-06,  3.00956e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  4.36493e-05,  3.84319e-05,  2.89711e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.17932e-06,  1.65462e-06,  6.25592e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  9.60543e-07,   7.0666e-07,  4.08337e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.09109e-06,  5.48554e-07,  4.08896e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(   7.2191e-06,  5.17431e-06,  3.50404e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.83972e-05,  2.28261e-05,  1.58995e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.74265e-06,  1.95619e-06,   9.9344e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(   4.0124e-07,  3.01244e-07,  1.80642e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.97906e-07,  1.30581e-07,  1.08971e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.27176e-07,  1.05154e-07,  1.16995e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.03965e-07,  8.49024e-08,  1.86594e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  9.09625e-08,  7.38343e-08,  1.90259e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  9.03926e-08,  9.68981e-08,  5.88603e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  9.20398e-06,  7.87491e-06,  3.83638e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  8.36275e-06,  6.60703e-06,  3.21657e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.23216e-06,  1.02998e-06,  2.27609e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  4.06701e-07,  2.99023e-07,  1.00894e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.48344e-07,  3.24513e-07,  7.22164e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.17902e-07,  4.98814e-07,  7.16884e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.72615e-07,  1.48169e-07,  8.67925e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  4.22228e-07,  2.35646e-07,  4.05589e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(   1.1932e-06,  6.68325e-07,  1.90511e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.81696e-05,  2.07818e-05,  1.66132e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.17688e-05,  5.67307e-06,  4.41608e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  9.11602e-07,  5.10165e-07,  3.67577e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  9.84857e-07,  4.37964e-07,   3.0252e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.92221e-06,  1.34838e-06,  9.71922e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  4.58761e-05,  3.13343e-05,  2.50639e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.76411e-06,  1.22803e-06,  7.72542e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.12242e-06,  5.08717e-07,  3.64174e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.11963e-06,  1.17432e-06,  8.77335e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  4.25367e-05,  2.91607e-05,  2.43417e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  3.68377e-06,   2.0126e-06,  9.36465e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.22471e-06,  4.59937e-07,   3.0473e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  5.38464e-07,  3.87974e-07,  2.58682e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  7.55094e-07,  3.96023e-07,  3.28905e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  6.06493e-06,  4.18467e-06,  2.53557e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(   2.4391e-05,  1.53493e-05,  1.22569e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.81019e-06,  1.44902e-06,   6.4808e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  3.86339e-07,  1.96703e-07,  1.29293e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.48941e-07,  7.98472e-08,  8.43848e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.12178e-07,  6.34816e-08,  1.28696e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.19381e-07,  5.70299e-08,  7.95614e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(   1.0575e-07,  5.87221e-08,  6.53635e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.55782e-06,  1.16738e-06,  5.06276e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   4.3943e-07,  2.56736e-07,  8.38535e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  3.73062e-07,  7.45838e-07,  8.82577e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.72007e-07,  8.76962e-07,  7.24939e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   1.2755e-07,   6.4538e-07,  7.03225e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.61775e-07,  9.10732e-07,  5.77931e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  2.29114e-07,  2.30802e-07,  8.60623e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  5.94417e-07,  3.73474e-07,  1.91465e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.03446e-05,  7.12311e-06,  7.01271e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.78663e-05,   1.5058e-05,  8.70746e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.01109e-06,   6.4046e-07,  4.35594e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.28317e-07,  2.72948e-07,  3.96039e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.53716e-07,  3.61794e-07,  4.29046e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.82126e-06,  2.19662e-06,  8.52117e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  3.05604e-05,   2.5758e-05,  1.81433e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.33939e-06,   7.2856e-07,  4.15493e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.95525e-07,  3.64327e-07,  2.45023e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.13774e-06,  5.51711e-07,  5.59033e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.90047e-05,  1.66253e-05,  1.33987e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.42705e-05,  1.04517e-05,  5.45567e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  9.12229e-07,  4.18221e-07,  2.61667e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.77423e-07,  2.87419e-07,  1.31527e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  2.75133e-07,  2.92561e-07,  1.83757e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.48952e-07,  3.78038e-07,  1.80195e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.73748e-06,  3.27154e-06,  2.00143e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.64627e-05,   1.3141e-05,  8.24773e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   1.8544e-06,  1.01604e-06,  5.16063e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  2.69626e-07,  1.43335e-07,   1.2233e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.48033e-07,  6.45486e-08,  5.07599e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  5.04667e-08,  5.93017e-08,   1.9206e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.43401e-08,  5.89968e-08,  2.94434e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.26633e-07,  8.17835e-08,  9.58684e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.32871e-07,  5.64889e-08,  6.96008e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.45138e-07,  5.62967e-08,  1.05756e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.10749e-07,  7.53038e-08,  6.50505e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.10698e-07,  1.78767e-07,  5.32209e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.50963e-07,  1.13165e-06,  5.52665e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.84913e-07,  8.05385e-07,  1.29322e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.06225e-06,   1.3237e-06,  6.14929e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.97853e-05,  1.58076e-05,  1.26674e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.86111e-06,  1.08251e-06,  5.38633e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.44685e-07,  2.60848e-07,  1.76775e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  3.40251e-07,  2.03933e-07,  1.19044e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.57123e-07,  3.04394e-07,  1.61115e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  7.53171e-06,  4.55462e-06,  1.73478e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.08813e-05,  1.78619e-05,  1.40096e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  9.85683e-07,  4.37101e-07,  3.93787e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  3.23868e-07,  2.61239e-07,  2.80185e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.97694e-07,  3.48358e-07,   1.1546e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.20219e-06,  2.77559e-06,  2.58333e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.28153e-05,   1.8799e-05,  1.28949e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.20956e-06,  5.72738e-07,  3.07287e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.70514e-07,  2.11394e-07,  1.85879e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  3.89155e-07,  1.61256e-07,  7.34206e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.07641e-07,  2.40969e-07,  1.33605e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.09898e-07,  1.87463e-07,  1.58143e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  3.98157e-06,  2.65823e-06,  1.62065e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.29124e-05,  1.00161e-05,  6.55757e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.42525e-06,  7.35822e-07,  1.02023e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.80564e-07,   1.3832e-07,  2.84882e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  1.04671e-07,  7.38477e-08,  1.33911e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.56291e-08,  5.91731e-08,  1.94187e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.37269e-07,  3.77304e-08,  4.43693e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.00264e-07,   4.0078e-08,  6.28193e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.08918e-07,  3.67858e-08,  7.80195e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.28256e-07,  4.24179e-08,  3.66903e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  1.40472e-07,  6.43934e-08,  3.81522e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  1.96656e-07,  3.42393e-07,  6.45466e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   6.8151e-07,  1.11588e-06,  1.84339e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  1.43081e-05,  9.51051e-06,   6.3482e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.96625e-06,  4.62756e-06,  3.08578e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.67134e-07,   4.7104e-07,  1.27162e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.32073e-07,   2.5606e-07,  1.47886e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.65614e-07,  1.59826e-07,  8.24651e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.67056e-07,  3.13803e-07,  1.31705e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   1.1786e-05,  7.50569e-06,  3.64624e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   1.4232e-05,   1.0491e-05,  7.83527e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.78979e-07,  3.18276e-07,  2.45676e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.88548e-07,  2.15573e-07,  1.94026e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.76301e-07,  1.71253e-07,  1.96644e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  8.74436e-07,  1.20218e-06,  9.27333e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.15411e-05,  1.62202e-05,  1.01936e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.77334e-06,  9.33717e-07,  5.43224e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.51797e-07,  2.18932e-07,  2.57639e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.12086e-07,  1.09607e-07,  1.89292e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.52487e-07,   1.9252e-07,  1.49386e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   1.9323e-07,  1.47977e-07,  2.42547e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.32414e-07,  1.73309e-07,  3.04646e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.39907e-06,  2.23106e-06,  2.09298e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  1.16844e-05,  7.69084e-06,  6.68695e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   1.0649e-06,  5.32181e-07,  6.82279e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   1.5641e-07,  8.37964e-08,  2.76647e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  8.29707e-08,  7.32487e-08,  1.29013e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.30004e-07,   4.8629e-08,  6.95299e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.68724e-07,  4.07702e-08,  5.09494e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  5.44389e-07,  4.16415e-08,  9.06055e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  8.26418e-07,  3.78834e-08,   4.1948e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.65166e-07,  7.45004e-08,  6.05046e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.96651e-07,   1.5686e-07,  1.07421e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  5.43227e-06,  4.04174e-06,  2.17108e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  9.64902e-06,  8.10338e-06,  5.06242e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(   4.7596e-07,  3.60947e-07,  2.96679e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.01722e-07,  1.45105e-07,  2.60007e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.38312e-07,  2.15656e-07,  2.42849e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.80577e-07,  2.64654e-07,  1.42525e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(   3.4696e-07,  3.33486e-07,  2.22282e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(   1.2751e-05,  9.68836e-06,  6.14455e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  6.70759e-06,  4.98484e-06,  3.84445e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.17531e-07,   2.7725e-07,  2.12845e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.89437e-07,  1.37032e-07,  2.20578e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.11147e-07,  1.44007e-07,  3.01656e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.63477e-07,  1.13483e-06,  3.67102e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  9.12472e-06,  8.22115e-06,  5.39949e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  9.38268e-06,  5.62644e-06,  3.60643e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.38397e-07,  1.98226e-07,  2.13803e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.60683e-07,   1.0887e-07,  7.98328e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.07754e-07,  9.26616e-08,  9.41101e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.03772e-07,  9.05275e-08,  4.38601e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(   1.3771e-07,  1.27218e-07,  8.97929e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.46512e-07,    1.318e-07,  1.15236e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.80493e-06,  1.78803e-06,  2.19449e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(   8.2782e-06,  6.03263e-06,  4.08157e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  8.28969e-07,  4.32481e-07,  4.99136e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  1.14984e-07,  9.31059e-08,   1.4513e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.37007e-08,  4.07977e-08,  1.73012e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.96357e-08,  3.20905e-08,   1.5842e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.00469e-07,  3.43349e-08,  1.36464e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  8.38648e-07,  6.36199e-08,  1.09988e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  5.19645e-07,   9.5026e-08,  1.49529e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.00801e-06,  5.49979e-07,  2.76268e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.13385e-05,  9.04786e-06,  4.76777e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.02452e-06,  9.44282e-07,  3.29377e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.91938e-07,  1.51639e-07,  1.52365e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.38119e-07,  8.13675e-08,  2.81623e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.12295e-07,  6.83775e-08,  5.25872e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   1.1946e-07,   8.5565e-08,    8.765e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  4.54272e-07,  2.28491e-07,  1.98204e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.32217e-05,  1.02616e-05,  6.36897e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.04243e-06,   1.8349e-06,  9.76605e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.15197e-07,  2.31698e-07,  1.13006e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.92382e-07,  1.51877e-07,  1.71053e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.43096e-07,  1.56396e-07,  3.48497e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.33353e-07,  1.50068e-06,  1.84401e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.20544e-06,   1.2783e-06,  5.20039e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.37663e-05,  9.86371e-06,  6.14104e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  4.72254e-07,  3.03671e-07,  2.00776e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.39597e-07,  1.26141e-07,  1.73067e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.16159e-07,  9.59191e-08,  4.35815e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  7.92713e-08,  3.72046e-08,  3.27634e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   1.5318e-07,  6.62453e-08,  1.76249e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.01783e-07,   1.0152e-07,  2.30641e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   1.8163e-07,  9.80585e-08,  2.03358e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   2.2854e-06,  1.52014e-06,  8.33201e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  6.70949e-06,  4.82112e-06,  3.22786e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  6.38747e-07,  4.36438e-07,  6.28158e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.52113e-08,  1.89619e-08,  6.76047e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  3.02845e-08,  2.35635e-08,  1.03284e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  6.33086e-08,  3.35315e-08,  1.31659e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  7.07049e-07,   6.5472e-08,  5.74684e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  4.36544e-07,  1.68739e-07,  1.12445e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  6.21634e-06,  5.20318e-06,  2.64959e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  4.53172e-06,   2.6575e-06,  1.58485e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  4.09357e-07,  1.11143e-06,  8.12052e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.01403e-07,  1.42733e-07,  1.23485e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  9.31735e-08,  5.76938e-08,  1.20255e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.15089e-07,  5.23464e-08,  3.41605e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.29152e-07,  8.17854e-08,  1.73986e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  4.32768e-07,    2.649e-07,  1.53524e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.23622e-05,  9.12269e-06,  5.86897e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(      1.2e-06,  6.31735e-07,  2.99948e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.41588e-07,  1.47037e-07,  8.15831e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.14033e-07,  1.46393e-07,  2.19271e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.19235e-07,  1.90909e-07,  4.67555e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.81866e-07,  1.73209e-06,  2.46947e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  9.52935e-07,  3.98379e-07,  1.87795e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.21286e-05,  8.53512e-06,  5.31733e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  8.70797e-07,  5.37119e-07,   4.8598e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.88721e-07,  1.48378e-07,  3.24115e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.10355e-07,  1.52983e-07,  8.95197e-08) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  6.47828e-08,  1.10053e-07,  1.17494e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.01055e-07,  1.05432e-07,  2.52686e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.27051e-07,  1.55248e-07,  9.15859e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  9.63157e-08,  1.66861e-07,  1.19887e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.40397e-07,  2.13089e-07,  1.24795e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.06843e-06,  1.44508e-06,  5.88811e-07) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  5.42387e-06,  4.75162e-06,  2.99718e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    
    gl_FragColor = vec4(rgb.x, rgb.y, rgb.z, rgba.w);
    return;
}