/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * diffraction eye
 * @brief ܌tB^iځj
 * 
 * @param F Fl
 *
 * ܂ɂu[ʂV~[g܂D
 * ~`̍iƂ܂lāClԂ̖ڂɉf鑜V~[g܂D
 *
 * Reference ::
 * Kakimoto M., Matsuoka K., Nishita T., Naemura T., Harashima H.
 * "Glare generation based on wave optics".
 * Computer Graphics Forum, Vol. 24, No. 2. pp.185--193, 2005-7.
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
#extension GL_ARB_texture_rectangle: enable

// Screen Efects󂯎
uniform sampler2DRect se_rgbaTex;    // RGBA
uniform vec2 se_screenSize;
uniform float se_cameraZoom;
uniform float se_cameraFocus; 

/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * main
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
void main(void) {
    vec2 uvPos = gl_FragCoord.xy;
    vec2 pos;
    vec4 rgba = texture2DRect(se_rgbaTex, uvPos).xyzw;
    vec3 rgb = vec3(0.0, 0.0, 0.0);
    
    // Fl
    float FValue = 1.0e+9;
    if (se_cameraFocus != 0.0) {
        FValue = 2.0 * 36.0 * (0.001 * se_cameraZoom) * (0.001 * se_cameraZoom)
                 / se_cameraFocus;
    }
    if (FValue > 512.0) {
        FValue = 512.0;
    }
    
    float pixWidth = max(se_screenSize.x, se_screenSize.y);
    float dotPitch = 0.036 / pixWidth;
    float airyRadius = 1.2196 * 435.8e-9 * FValue;
    float airyZeroPoint = 4.61089134947891;    
    float scalingFactor = airyRadius / airyZeroPoint / dotPitch;    // J[lԂ1pxXN[ŉpxɑ邩
    
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(    1.949e-06,   1.4762e-06,  1.88044e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.28161e-06,  1.78472e-06,   1.9821e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.12162e-06,  1.77757e-06,   2.6945e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.38295e-06,    1.666e-06,  2.83342e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.49768e-06,  2.12022e-06,  3.16839e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(   1.6855e-06,  1.96336e-06,  2.18732e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.98895e-06,  1.37795e-06,  2.06504e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.74772e-06,  1.36468e-06,  2.17796e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(   1.8202e-06,  1.39578e-06,   1.9103e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.82291e-06,  1.99765e-06,  1.69107e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(   1.9646e-06,  1.50003e-06,  2.26838e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.54398e-06,  3.16522e-06,  1.78209e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  3.87059e-06,  2.32347e-06,  2.13258e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.63733e-06,  1.36232e-06,   3.4918e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  3.42805e-06,  2.02206e-06,  1.37868e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.91583e-06,  2.06946e-06,  3.50137e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  3.75353e-06,  1.64801e-06,  1.84571e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.05109e-06,  1.97455e-06,   2.9113e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.96551e-06,  2.72079e-06,  2.35487e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.44929e-06,   1.8866e-06,  1.57121e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.10949e-06,  1.42834e-06,  1.81212e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.42557e-06,  1.71221e-06,  1.84567e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.54056e-06,  2.29401e-06,  1.97848e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.36845e-06,  1.66544e-06,  1.77118e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.57778e-06,  1.13981e-06,  1.70572e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(   2.2379e-06,  1.66458e-06,  2.19353e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.91078e-06,  1.43052e-06,  2.38516e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  2.09075e-06,   1.4226e-06,  1.55175e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.49337e-06,  1.85239e-06,  2.02405e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.52066e-06,  1.47806e-06,  2.35994e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(  1.37416e-06,  1.25791e-06,  2.41897e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.79686e-06,  2.10597e-06,  2.00451e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.61392e-06,  2.71684e-06,  1.91335e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.32717e-06,  2.36505e-06,  2.34411e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.76861e-06,   1.8605e-06,   2.0541e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.41459e-06,  1.56917e-06,  1.92679e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  3.31938e-06,  2.28592e-06,  2.59348e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(   2.1423e-06,  2.36797e-06,  2.46069e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.93576e-06,  1.90962e-06,  2.08033e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.84927e-06,  1.61284e-06,  2.30418e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.25738e-06,  2.47557e-06,  1.79005e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.21001e-06,  2.09201e-06,  1.90655e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  3.00774e-06,  2.53349e-06,  1.81866e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  4.25758e-06,  3.58059e-06,  2.35595e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.84811e-06,  2.54008e-06,  2.72132e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(   3.0724e-06,  2.54629e-06,  1.29494e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.86067e-06,  2.57772e-06,  3.19127e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.93433e-06,  2.79974e-06,  1.91119e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  3.05043e-06,  2.43336e-06,  2.69132e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  4.29511e-06,  2.68751e-06,  2.10252e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.47066e-06,  1.74099e-06,  1.22648e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.30163e-06,  1.53228e-06,  2.26146e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(   3.1018e-06,  2.47319e-06,  1.96716e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  3.03307e-06,   2.1789e-06,  1.90276e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.69874e-06,  2.08175e-06,   1.7278e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(   2.2595e-06,  2.20448e-06,  1.78079e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  1.75269e-06,   2.0598e-06,  1.72313e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.35002e-06,  2.07611e-06,  1.77659e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(   1.5955e-06,  2.41672e-06,  2.03843e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(    2.997e-06,  1.98003e-06,  1.99581e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.20329e-06,  1.98543e-06,  2.11394e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(  2.12724e-06,  2.39567e-06,  2.67171e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.50272e-06,  3.30707e-06,   3.2173e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.43956e-06,  2.72662e-06,   3.1334e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.42509e-06,  2.12926e-06,  3.20727e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.56519e-06,  3.19528e-06,  2.86702e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.24215e-06,  2.19578e-06,   2.6987e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.29527e-06,  2.89942e-06,  1.65615e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.68718e-06,  2.39536e-06,  2.73622e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   2.2827e-06,  1.81315e-06,  2.30287e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.86405e-06,  1.99567e-06,  2.03476e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   3.0366e-06,   2.4362e-06,  1.83128e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.11077e-06,  2.43395e-06,  1.98079e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.16951e-06,  3.40381e-06,   2.1398e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.79332e-06,  3.89009e-06,  3.44477e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.12049e-06,  2.93405e-06,  3.53658e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.71792e-06,  3.35933e-06,  1.91907e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.30693e-06,  3.78958e-06,  3.74646e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.47829e-06,  3.03066e-06,  2.75918e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   4.2174e-06,  3.83151e-06,  3.74529e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.62139e-06,  3.03235e-06,  2.44182e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.32617e-06,  2.76344e-06,  2.14183e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.92323e-06,  2.54609e-06,  2.32266e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.50312e-06,  3.58437e-06,  2.49938e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   2.3278e-06,  2.10182e-06,  2.00027e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.37664e-06,   2.4299e-06,  1.85172e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.65236e-06,  2.01216e-06,  2.87296e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.02884e-06,  2.45909e-06,  2.05746e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(   3.6657e-06,  2.58203e-06,  2.28757e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.97268e-06,  1.90663e-06,  2.79085e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  2.79718e-06,  2.50952e-06,  2.44526e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  4.61816e-06,  2.51804e-06,  2.42783e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(  3.28278e-06,  3.13702e-06,  2.81934e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  6.01427e-06,  3.43969e-06,  3.37609e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.29836e-06,  3.83998e-06,  3.58827e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.69829e-06,  5.14426e-06,  2.76478e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  6.78382e-06,  3.37388e-06,  2.04071e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.85646e-06,  4.45919e-06,  2.16921e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.69172e-06,  3.12314e-06,  2.25332e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.80376e-06,  3.41884e-06,  2.68328e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.55306e-06,  3.21063e-06,  2.70129e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(   3.7555e-06,  3.22169e-06,  2.63522e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.13623e-06,  2.56233e-06,  2.06138e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.19441e-06,  4.28885e-06,  2.67924e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.37155e-06,  2.81437e-06,  2.39636e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  8.55892e-06,   5.3226e-06,  4.19318e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  6.00294e-06,  3.40455e-06,  3.30005e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.56843e-06,  4.64458e-06,  2.09195e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.36625e-06,  4.09039e-06,  3.68394e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  6.90083e-06,  5.24196e-06,  2.53279e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.86718e-06,  3.29681e-06,  3.67138e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.98175e-06,   4.8586e-06,  2.69913e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.67493e-06,  3.45255e-06,  2.19624e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.87779e-06,   3.9256e-06,  3.22925e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  5.28029e-06,  4.17825e-06,  3.11903e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.74295e-06,   2.6394e-06,  2.19619e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(   4.6328e-06,  3.42553e-06,   2.4259e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  6.70292e-06,  3.02478e-06,  2.36721e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  2.79053e-06,  2.49307e-06,  2.50269e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(   3.8283e-06,  2.49106e-06,  2.90452e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  4.79951e-06,  2.24358e-06,  1.91216e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.11118e-06,  3.02438e-06,  3.12312e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  3.47967e-06,  2.42753e-06,  2.92319e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(  6.95547e-06,  2.56932e-06,   2.5644e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.16904e-06,   5.1438e-06,   3.6454e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  8.14972e-06,  4.03658e-06,  4.70754e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  8.10542e-06,   5.9629e-06,  5.53726e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  3.50492e-06,   5.4731e-06,  3.46224e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.80328e-06,  3.40941e-06,  4.34163e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  2.37905e-06,    3.101e-06,  3.77185e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(   5.3163e-06,  3.11964e-06,  3.06181e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.48374e-06,  4.90719e-06,  3.43982e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  3.48084e-06,  3.19355e-06,  4.24837e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.03556e-06,  3.25848e-06,  2.60958e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.10273e-06,  4.54716e-06,  3.42725e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(   5.5938e-06,  3.78016e-06,  3.21482e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  6.70941e-06,  5.93518e-06,  4.43988e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  6.04968e-06,  5.47819e-06,  4.99085e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.45525e-06,  4.52771e-06,  4.10616e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  9.76558e-06,  5.21707e-06,  4.55457e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.92038e-06,  4.51827e-06,  4.30897e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  7.63673e-06,  6.99168e-06,  4.65232e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.87849e-06,  4.84978e-06,  2.82036e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  6.10002e-06,  3.80433e-06,  2.79338e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  7.93317e-06,  4.74052e-06,  4.01696e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.85131e-06,  5.36314e-06,  2.89351e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.94778e-06,  3.74971e-06,  3.89543e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.61156e-06,  3.41922e-06,  2.89308e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.98348e-06,   3.7862e-06,  3.47547e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.00136e-06,  3.60012e-06,  3.27982e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.01593e-06,  4.98883e-06,  3.94445e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  5.14676e-06,  4.36434e-06,  2.88719e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  4.85981e-06,  2.93815e-06,  3.41372e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  3.95535e-06,  3.24181e-06,  4.58244e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(  6.13444e-06,  2.25225e-06,  4.72028e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  6.37692e-06,   5.4213e-06,  3.73396e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  7.40375e-06,   6.3258e-06,  3.88134e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.23573e-06,  6.31784e-06,  4.56325e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.05944e-05,  4.15278e-06,   4.0085e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.99101e-06,  6.56953e-06,  4.83376e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.66961e-06,  6.35866e-06,  4.20032e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  4.43697e-06,  4.98933e-06,     4.95e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  6.59168e-06,  4.93062e-06,  4.22734e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  5.43657e-06,  4.92851e-06,  4.20184e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  5.17111e-06,  5.12912e-06,  3.33807e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  9.26791e-06,   5.9784e-06,  3.17763e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(   7.2593e-06,  5.85874e-06,  4.14203e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.42316e-06,  5.78223e-06,  4.98054e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.05083e-05,  1.03495e-05,  6.59794e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  9.05325e-06,  6.70703e-06,  4.80259e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.20636e-05,  7.75016e-06,  5.93237e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.26192e-06,  9.14309e-06,  5.31535e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  9.47845e-06,  8.24498e-06,   5.9647e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.38908e-06,  4.93184e-06,   4.6164e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  7.45926e-06,  6.33954e-06,  4.27334e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.47954e-06,  6.06667e-06,   4.7688e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(   9.1675e-06,  5.97395e-06,  3.63006e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  6.84403e-06,  8.68084e-06,  3.95029e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  7.24525e-06,  4.24657e-06,  3.83129e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(    4.792e-06,  5.39502e-06,  3.86488e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(   4.0502e-06,  6.38603e-06,   3.6173e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  7.12721e-06,  5.52378e-06,  3.76386e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.67758e-05,  8.55687e-06,  4.22695e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.51197e-05,  4.53609e-06,  3.44497e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  1.11801e-05,   4.4569e-06,  3.97093e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(  8.13774e-06,  3.29522e-06,  3.63549e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.50224e-05,   3.9007e-06,  5.97695e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.01038e-05,  6.54675e-06,  6.48012e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   1.3422e-05,  6.24521e-06,  6.70826e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.86959e-05,  9.62494e-06,  4.63937e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.29402e-05,  9.63649e-06,  6.98815e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.30738e-05,  8.04893e-06,  8.79924e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.22469e-05,  5.09704e-06,  6.69297e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.08367e-05,  3.14486e-06,  5.39683e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.19011e-05,  8.12504e-06,    6.739e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  9.50235e-06,  5.69869e-06,  5.74145e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.01984e-05,   6.6036e-06,  5.33333e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.23894e-05,  7.64225e-06,  6.66526e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   1.2453e-05,  8.93549e-06,  5.89623e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.55848e-05,  1.04674e-05,  1.02144e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.30176e-05,  7.09732e-06,  6.55691e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.15244e-05,  1.17429e-05,  8.42187e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.31898e-05,  8.17633e-06,  7.71013e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.79183e-05,  1.17116e-05,  9.10098e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.26622e-05,  7.72809e-06,  5.98884e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.04716e-05,  9.88694e-06,  8.24961e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(   1.0668e-05,  8.44145e-06,  6.60862e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  9.86901e-06,  5.76645e-06,  5.09722e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  9.24728e-06,  7.94303e-06,  5.77328e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.05083e-05,  6.67095e-06,  5.40815e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.84717e-05,  6.64537e-06,  4.99322e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.39422e-05,  5.90797e-06,  5.41165e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.54604e-05,  5.17707e-06,  4.87163e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.25768e-05,  9.96927e-06,  3.49764e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.71827e-05,  1.11877e-05,  4.11861e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  2.21801e-05,  8.83034e-06,  6.47231e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(  1.20214e-05,  5.88554e-06,  5.29637e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.68584e-05,  8.41962e-06,  7.48893e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.03353e-05,  1.12547e-05,   6.0124e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.47793e-05,  1.29005e-05,  7.45949e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.54032e-05,  1.20969e-05,  7.96722e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.58255e-05,  1.37499e-05,  9.18652e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.23825e-05,  1.36132e-05,  9.49597e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.21536e-05,  1.18485e-05,  8.24778e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  7.68824e-06,  8.42342e-06,  7.17167e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.37061e-05,  6.99538e-06,  7.95493e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.42435e-05,  1.12552e-05,  8.50342e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.02262e-05,  8.82014e-06,  6.92784e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.46471e-05,   1.3239e-05,  8.10061e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.89884e-05,  1.08438e-05,  7.78453e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.01547e-05,  1.41572e-05,  1.26199e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.21349e-05,  1.62791e-05,  9.54709e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.54062e-05,  1.59849e-05,  1.20455e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.78988e-05,  1.34327e-05,  1.13315e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.43558e-05,   1.5405e-05,  1.01974e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.62463e-05,  1.07433e-05,  7.99006e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.85567e-05,  1.39987e-05,  7.77615e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.48279e-05,  1.43955e-05,  9.61908e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.29162e-05,  1.10672e-05,  9.46873e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.32989e-05,  8.39313e-06,  7.77017e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.65785e-05,   8.5944e-06,  8.47936e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.23045e-05,  1.26401e-05,  1.09864e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(   3.7352e-05,   2.5518e-05,  5.79056e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  4.67781e-05,  1.92221e-05,  6.38259e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  4.28351e-05,   1.2554e-05,   4.9035e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.90294e-05,  7.64407e-06,   3.5558e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  2.19316e-05,  8.57395e-06,  4.69998e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(  1.87667e-05,  7.64425e-06,  6.05523e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.03661e-05,  7.59696e-06,  7.72317e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(   2.1864e-05,  1.05487e-05,  6.84743e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(   2.5087e-05,  1.45584e-05,   1.0187e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.91126e-05,   2.2034e-05,  9.31798e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.71288e-05,  1.87389e-05,  1.26044e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.52378e-05,  2.30697e-05,   1.1201e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.38667e-05,  2.38506e-05,  1.89688e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(   2.0836e-05,  2.09367e-05,  1.57474e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  1.48148e-05,  1.84657e-05,  1.14853e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.11444e-05,  1.63738e-05,  8.43207e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.10943e-05,  1.83466e-05,  1.37639e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.43456e-05,  1.53162e-05,  1.05511e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.70724e-05,   1.6638e-05,  1.26809e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.35729e-05,  2.55331e-05,   1.9578e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.58406e-05,  2.05575e-05,  1.45481e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.79796e-05,  1.94017e-05,  2.06231e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.99983e-05,  2.23355e-05,  1.68691e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.20756e-05,  2.42151e-05,  1.58956e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.27781e-05,  1.95416e-05,  1.81258e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.82242e-05,  1.47961e-05,  1.45959e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.16293e-05,  1.75872e-05,  1.37252e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.08037e-05,  1.74666e-05,  9.23164e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.41622e-05,   2.5444e-05,  1.41955e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.18033e-05,  2.90626e-05,  1.19484e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  2.16091e-05,  2.43877e-05,  1.34033e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.44835e-05,  2.29769e-05,  1.81012e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  5.81184e-05,  2.92589e-05,  1.48133e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  5.42526e-05,  1.96487e-05,  8.83307e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  4.92661e-05,  1.75456e-05,  6.45211e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  4.14309e-05,  1.66742e-05,  4.32549e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(  3.47818e-05,  7.02386e-06,  5.06443e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   2.0078e-05,  1.33923e-05,  4.95611e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.38369e-05,  1.05986e-05,   5.6899e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.00525e-05,  1.81897e-05,  8.60603e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.27553e-05,  2.84792e-05,  1.11435e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(    7.716e-05,  3.89713e-05,  1.92535e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.09986e-05,  4.50465e-05,  2.24862e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.86391e-05,  3.03923e-05,  2.32363e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.92955e-05,  4.31938e-05,  2.49853e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   4.0606e-05,  3.81036e-05,  2.40523e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.81141e-05,  2.48967e-05,  1.70822e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.02736e-05,  2.69706e-05,  1.90933e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.14088e-05,  2.15578e-05,  2.00581e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.69449e-05,  2.99378e-05,  2.38249e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.83764e-05,  3.77855e-05,  2.40252e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   4.1778e-05,  4.13219e-05,  2.97581e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.55731e-05,  4.71307e-05,  2.42365e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.08201e-05,  3.63419e-05,  2.89722e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.29348e-05,  4.02723e-05,  2.04636e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.60014e-05,  3.71841e-05,  2.16355e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   3.8896e-05,  2.64307e-05,  2.11506e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(   2.4137e-05,  3.94693e-05,  1.91221e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  2.82975e-05,  2.09489e-05,  2.06037e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  4.83123e-05,  3.25622e-05,  2.77366e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  0.000111965,  8.54826e-05,  4.21288e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  8.33846e-05,  8.61624e-05,  3.77032e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  5.02412e-05,  6.63564e-05,  2.01893e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  9.48419e-05,  5.72706e-05,  1.86731e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  6.21787e-05,  5.02501e-05,  9.25032e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  7.06837e-05,  2.86385e-05,   9.4151e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  7.14508e-05,  2.43499e-05,  6.53463e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(  3.91769e-05,  1.81681e-05,  4.26113e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  6.67872e-05,  1.92684e-05,   7.7155e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  9.43737e-05,  3.30416e-05,  9.22607e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  3.79846e-05,  3.77219e-05,   1.1677e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  8.17783e-05,  3.03119e-05,  1.53399e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  8.40436e-05,   4.1636e-05,  1.58554e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  9.80357e-05,  7.73875e-05,  2.73219e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.99556e-05,  8.41001e-05,  4.71105e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000121123,  6.69611e-05,  5.06422e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  8.39233e-05,  7.30198e-05,  5.40071e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  9.21277e-05,  6.22154e-05,  5.12722e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  6.94215e-05,   4.5326e-05,  3.41735e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  5.19573e-05,  5.53648e-05,  3.57348e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  5.29573e-05,   5.0074e-05,  3.36714e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(   8.2786e-05,  5.88591e-05,  4.61901e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.73123e-05,  6.03456e-05,  5.14361e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000101738,  5.17056e-05,  6.38622e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.28276e-05,  6.99174e-05,  5.58427e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.63944e-05,  5.57539e-05,  4.79788e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.51919e-05,  6.53448e-05,  3.72589e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(   6.4413e-05,  4.15142e-05,  4.17793e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  4.94143e-05,  4.75968e-05,  4.52541e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  6.79866e-05,  0.000111848,  7.19872e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  7.63777e-05,  0.000106877,   0.00012655) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  8.57199e-05,  6.59597e-05,  6.75448e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000149309,  0.000114041,  5.40361e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000123035,  8.12017e-05,  4.33101e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000166269,   0.00011369,  2.93371e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000111217,  6.58782e-05,   1.8627e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  0.000105065,  4.90348e-05,  9.61179e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(   6.0741e-05,  4.56548e-05,  7.22412e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(  9.51872e-05,   2.2206e-05,  6.36648e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   4.4274e-05,  2.49004e-05,  4.81781e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   7.6336e-05,  4.75347e-05,  8.10349e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000141214,  5.00199e-05,  1.39724e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   0.00017555,  9.57023e-05,  2.30488e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000117917,  0.000118924,  4.70365e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000129804,  9.57628e-05,  4.61598e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000105945,  0.000117707,  7.06213e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000153452,  0.000137979,  9.55436e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000169426,  0.000120743,  0.000126291) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  9.35564e-05,  0.000143445,  0.000103055) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000101279,  0.000145163,  9.86367e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   0.00010051,  8.84504e-05,  6.65886e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  9.10871e-05,  7.77004e-05,  7.25501e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000138072,  0.000102417,  8.42314e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000149574,  0.000108037,  8.53554e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000155481,  0.000135918,  9.14906e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000139927,   0.00011435,  0.000102119) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000122782,  0.000103899,  8.55389e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  9.96401e-05,  0.000109334,  7.26745e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000171501,  7.18844e-05,  8.15941e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000216159,  0.000105293,   0.00016473) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000244514,  0.000148747,  0.000110661) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000281072,  0.000198263,  0.000170822) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(   0.00021711,  0.000193501,  0.000145137) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000298291,  0.000205407,  0.000121803) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000238486,  0.000144522,  8.54507e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(     0.000128,    0.0001346,  6.74758e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000182879,  0.000124801,   2.6646e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000108528,  7.77337e-05,   1.4951e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  0.000124334,  6.88333e-05,  8.29913e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(  8.85363e-05,  3.15779e-05,  4.22494e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  9.02779e-05,  5.59747e-05,  6.06905e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000128953,  6.21488e-05,  1.03988e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000158187,  6.89689e-05,  2.01145e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000188766,  9.89415e-05,  3.27341e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000114367,  0.000147059,  7.40629e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000232498,  0.000261641,  9.03091e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000394477,  0.000210414,  0.000194499) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000331033,  0.000306544,  0.000192457) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000328362,  0.000242468,  0.000246767) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000206675,   0.00031258,  0.000223645) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000295113,   0.00024341,  0.000270543) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000197939,   0.00022728,    0.0002365) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000217336,  0.000174753,  0.000187811) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000251486,   0.00017814,  0.000157454) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000260891,  0.000307238,  0.000225849) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000367318,  0.000309146,  0.000290303) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000317653,  0.000288971,  0.000202377) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000351907,  0.000197989,  0.000204123) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000214055,  0.000280574,  0.000212523) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000182397,  0.000391109,  0.000263138) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000360609,    0.0005705,  0.000322834) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000453292,  0.000427769,  0.000387655) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000419756,  0.000502281,  0.000377205) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000343904,  0.000385941,  0.000281862) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000374584,  0.000233563,   0.00022498) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000215518,  0.000250949,  0.000121906) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000247643,   0.00020845,  0.000104002) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000179349,  0.000126247,  4.64557e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000115617,  7.56766e-05,  2.83811e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  0.000119166,  5.22292e-05,  1.13372e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(  4.51845e-05,  3.85481e-05,  6.54568e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000226334,  0.000102928,  8.81431e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000189544,  0.000173831,  1.78414e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000530001,  0.000170501,  4.60694e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000563351,   0.00025099,  0.000109581) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000579807,  0.000384813,  0.000200399) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000406907,  0.000473765,  0.000126351) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000470298,  0.000417874,  0.000248289) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00056868,  0.000444706,  0.000386739) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000575169,  0.000646977,  0.000417519) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000632505,  0.000701292,  0.000708893) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000718446,   0.00071053,  0.000683693) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000812396,    0.0006212,  0.000631588) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000538556,  0.000593727,  0.000526475) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000633176,  0.000591893,  0.000475266) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000988816,  0.000785512,  0.000593298) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00136684,   0.00100526,  0.000707769) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00123424,   0.00104771,  0.000773842) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000774243,   0.00075216,  0.000476868) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000760573,  0.000850667,  0.000750363) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(   0.00109474,  0.000864643,   0.00104279) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000848766,  0.000854128,  0.000993837) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000649295,  0.000753631,  0.000700305) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000619648,  0.000677058,  0.000577801) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000444035,  0.000376698,  0.000278105) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000320725,  0.000338002,  0.000270623) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000235954,   0.00023626,  0.000133607) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000294816,  0.000145138,  7.25712e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000192704,  0.000185066,  6.33895e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000110707,  7.51749e-05,  3.49282e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000139422,  5.08561e-05,  2.15163e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(  0.000137728,  5.39279e-05,  9.31447e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00020932,  7.81958e-05,  1.03665e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00011971,  5.46509e-05,  1.42246e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000109033,  0.000181938,  4.11593e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000573177,  0.000329783,  0.000111461) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000450993,   0.00030002,  0.000171408) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00050229,  0.000694728,  0.000316581) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000697475,  0.000768703,  0.000587615) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00144486,  0.000923531,  0.000985875) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00112708,   0.00142215,   0.00153175) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00214989,   0.00167475,   0.00105774) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00187826,   0.00254511,   0.00267038) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00165438,   0.00244879,   0.00264756) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00140277,    0.0021366,   0.00296995) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00313193,    0.0024313,   0.00210392) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00463406,   0.00416174,   0.00349398) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(    0.0178943,    0.0125904,    0.0103909) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00473614,   0.00435994,   0.00401887) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00201076,   0.00219005,   0.00252186) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00190968,   0.00242609,   0.00251795) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00114559,   0.00111312,   0.00169177) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000764286,   0.00109665,   0.00121338) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00066717,   0.00102307,  0.000738977) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000497447,  0.000560048,  0.000672463) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000720917,  0.000324641,  0.000318377) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000398328,  0.000413089,  0.000311003) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000220316,   0.00026205,  0.000162777) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000225355,  0.000197382,  9.85431e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(   0.00021705,   0.00014126,  5.51122e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000125323,  8.37946e-05,  3.19329e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  0.000118409,  6.46957e-05,  1.54626e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(  6.72214e-05,  4.03797e-05,  6.80518e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  7.30738e-05,  4.47998e-05,  8.80748e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000123692,  6.10158e-05,   1.7005e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000128269,  0.000143875,  4.10682e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000299972,  0.000114664,   5.7652e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000359106,  0.000187616,  0.000100182) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000370878,  0.000397016,  0.000226255) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00032678,  0.000424497,  0.000312651) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000885994,  0.000527476,  0.000466694) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000644433,  0.000884816,  0.000802925) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000628586,  0.000914969,  0.000799282) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000822788,   0.00121778,   0.00200209) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00225673,   0.00115891,   0.00235969) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00357752,   0.00429234,   0.00281329) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00371982,   0.00568906,   0.00845484) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(    0.0109025,    0.0115091,    0.0110084) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(     0.776489,     0.791637,     0.810943) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(    0.0185435,    0.0141437,    0.0131937) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00361016,   0.00622456,   0.00886765) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00411545,   0.00428925,   0.00323071) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00272732,   0.00136986,   0.00273559) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000777795,   0.00153173,   0.00221438) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000762822,  0.000895676,  0.000829369) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000743101,  0.000934668,  0.000792916) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000793913,   0.00050243,    0.0005283) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000498802,  0.000493539,  0.000332821) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000396256,  0.000425417,  0.000231786) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000363525,  0.000186294,  9.98081e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000296353,  0.000114229,  6.37291e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000185137,  0.000154219,   4.3312e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000118266,  5.52694e-05,  1.67263e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  7.36953e-05,   5.1008e-05,  9.54034e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  7.13841e-05,  4.22861e-05,  6.91698e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000109701,  6.39945e-05,  1.32696e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000115278,  7.07833e-05,  3.28142e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000225764,   0.00012864,  5.46948e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000245469,  0.000184527,  9.35748e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000213487,   0.00024224,  0.000155712) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00039525,  0.000456257,   0.00031596) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000600261,   0.00030395,  0.000308629) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000596468,  0.000549959,  0.000673963) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000624995,  0.000920021,  0.000682431) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000720587,   0.00111338,   0.00116422) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00101331,   0.00107108,    0.0016967) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00171347,   0.00208471,   0.00230774) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00172439,   0.00194973,   0.00233607) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00343925,   0.00379184,   0.00320997) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00995059,    0.0102118,    0.0075069) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00456996,    0.0038637,   0.00326504) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00240525,   0.00217383,   0.00192126) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00125612,   0.00175709,   0.00278449) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00148651,   0.00219617,   0.00228568) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00176546,   0.00239979,   0.00255698) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00188016,   0.00153601,   0.00109699) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00138062,   0.00152929,   0.00141234) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00128132,   0.00092153,   0.00108697) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000854541,  0.000746791,  0.000585727) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000545049,  0.000762444,  0.000311473) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(   0.00049719,  0.000391246,   0.00020339) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000622869,  0.000355714,  0.000120007) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000109762,  0.000185492,  4.63338e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000117687,  6.73742e-05,  1.46621e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(  0.000254365,  8.12908e-05,  1.02444e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000137147,  4.99736e-05,  9.09776e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000148388,  5.29429e-05,  1.84253e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  9.13326e-05,  7.25722e-05,  3.70719e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000194968,  0.000167913,  6.14172e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00026413,  0.000149222,  7.06011e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000227349,  0.000217653,   0.00012883) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000316196,   0.00033182,  0.000258663) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000433219,   0.00040627,  0.000276096) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00058306,  0.000610423,  0.000553968) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000679678,  0.000765876,  0.000689321) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000805065,   0.00091079,  0.000876406) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00104404,  0.000754257,   0.00108821) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000703279,  0.000762612,  0.000704864) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000731247,  0.000676012,  0.000438701) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00104831,  0.000934319,  0.000699167) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(   0.00134589,   0.00096858,  0.000691922) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000905475,  0.000738552,  0.000569645) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000581525,   0.00055228,  0.000441735) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000572595,  0.000506997,   0.00048856) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000638076,  0.000572234,  0.000604101) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000660526,  0.000657601,  0.000622915) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000594877,  0.000648344,  0.000662067) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000535707,  0.000688492,  0.000396445) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000579149,  0.000403836,  0.000373261) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000446021,  0.000385946,  0.000261146) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000358825,  0.000450577,  0.000119197) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000507491,  0.000313128,  0.000178566) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000486643,  0.000250016,  0.000110088) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000549977,  0.000160341,  4.82505e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000206275,  0.000179251,   1.7173e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(  0.000224975,  0.000116146,  1.04686e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  4.65613e-05,  4.16114e-05,  6.26474e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000121068,  5.37397e-05,  1.13277e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000102261,  6.13366e-05,  2.71049e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000181262,  0.000122628,  4.28316e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000241643,  0.000210462,  0.000101465) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000237567,  0.000231136,  0.000115093) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000335619,   0.00022611,  0.000218915) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000374265,  0.000373412,  0.000272629) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(   0.00039639,  0.000456062,  0.000368994) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000477876,  0.000426902,  0.000366382) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000330315,  0.000517702,  0.000316284) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000192111,  0.000366967,  0.000226011) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000199498,  0.000292087,  0.000188424) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000306092,  0.000174564,  0.000189995) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000294164,  0.000261804,  0.000197036) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(   0.00028653,  0.000246923,  0.000247748) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(   0.00023224,  0.000289825,  0.000216007) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000252277,  0.000188047,   0.00014755) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000197099,  0.000175381,  0.000174433) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000205389,  0.000196731,  0.000217743) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000263552,  0.000195257,  0.000267543) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000202104,  0.000311059,  0.000224796) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000323606,  0.000217191,  0.000218703) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000275746,  0.000294182,  0.000186103) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000339339,  0.000199778,  0.000206484) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(    0.0002655,  0.000266681,  8.64008e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000116261,  0.000155322,  7.70988e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000169287,  0.000100512,  3.23612e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000155489,  6.09488e-05,  2.02674e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  0.000133538,  5.26632e-05,  1.00357e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(  8.90585e-05,  5.04669e-05,  6.35267e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  8.25643e-05,  2.63032e-05,  3.92743e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000111355,  6.43526e-05,  7.52742e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000112432,  8.53726e-05,  1.33774e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000167107,  0.000119133,  2.61246e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   0.00014045,  0.000123874,  6.33442e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000218203,  0.000150833,  7.82976e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000282051,   0.00020818,  0.000109162) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000200907,  0.000184767,  0.000141572) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000221296,  0.000191779,  0.000157583) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000229932,  0.000154429,  0.000100261) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000184069,  8.59817e-05,  0.000149209) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000157971,  6.97278e-05,  7.76796e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  8.72679e-05,   9.1621e-05,  7.05404e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000112992,   9.7933e-05,  8.39169e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   0.00013647,  0.000117665,  9.86405e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   0.00014316,  0.000122962,  9.46914e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000152148,   0.00010361,  8.45334e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000139784,  9.95698e-05,  8.37851e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  8.11109e-05,  7.36763e-05,  6.55593e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  9.78152e-05,  9.04604e-05,  6.64571e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   8.1772e-05,  0.000136055,  8.59135e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(   0.00010149,  0.000121577,  9.90676e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000152215,  0.000131276,  0.000115147) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000140189,  0.000141491,  9.80988e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  9.57964e-05,  0.000116931,  6.83954e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000111142,  9.21517e-05,  4.40559e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000123799,  0.000100817,  4.51457e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  0.000168873,  9.68674e-05,   2.5018e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(    0.0001287,  5.25376e-05,  1.46247e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  8.69004e-05,  5.23655e-05,  7.88043e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(  4.18894e-05,  2.39357e-05,  5.20903e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  8.91954e-05,  2.08926e-05,  6.98574e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  6.69011e-05,  4.45352e-05,  7.01386e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000100502,  4.53703e-05,   8.2945e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  9.87791e-05,  6.04259e-05,  1.88443e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   0.00015591,   0.00010372,  2.88202e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   0.00012466,  7.59263e-05,  3.90697e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000144507,  0.000100226,  4.65959e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  9.21784e-05,  6.26263e-05,  6.05729e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  8.56299e-05,  9.85915e-05,  0.000117136) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  5.90262e-05,  9.99411e-05,  7.49376e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  4.68184e-05,   4.7369e-05,  4.45938e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  5.62553e-05,  4.20495e-05,  4.02193e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   7.3339e-05,  6.16303e-05,  3.35569e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  7.09886e-05,  5.25394e-05,  4.44194e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  6.28832e-05,  6.62938e-05,  5.41428e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  9.76056e-05,  5.37516e-05,  5.38163e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  7.45992e-05,  6.19466e-05,  5.08634e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  7.65845e-05,  5.99542e-05,  4.86896e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  4.83547e-05,  4.99493e-05,  3.18189e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  4.84549e-05,  4.79544e-05,  3.47528e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  6.75824e-05,  4.78093e-05,  3.30101e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   7.5619e-05,  5.76973e-05,  4.82226e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  8.79195e-05,   6.2815e-05,  5.44932e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000106598,  6.27401e-05,  4.74549e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  7.67731e-05,   8.6488e-05,  4.67263e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  0.000110734,  7.88561e-05,  2.93438e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  8.04214e-05,  4.20253e-05,  1.66732e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(   7.1531e-05,  3.13922e-05,  1.43207e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  3.62821e-05,  3.16819e-05,  1.21652e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  7.90451e-05,  3.37934e-05,  8.88783e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(  6.92038e-05,  1.95054e-05,  7.29347e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.65207e-05,  1.56584e-05,  4.21331e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  6.43925e-05,  2.30723e-05,   6.0174e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  6.76979e-05,  2.42457e-05,  9.79762e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  6.06763e-05,  4.51258e-05,  9.45958e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  8.43892e-05,  5.24055e-05,  1.63135e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.08757e-05,  6.28899e-05,  1.86556e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  6.92298e-05,  8.05237e-05,  3.31646e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  0.000104912,  8.92853e-05,  4.34187e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.94514e-05,  3.22083e-05,   2.9179e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.82321e-05,  2.32054e-05,  1.83812e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.16148e-05,    3.521e-05,   1.8745e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.93613e-05,  2.46315e-05,  2.00804e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.60572e-05,  3.71657e-05,  2.23598e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.69778e-05,  3.95057e-05,  2.04357e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.46848e-05,  3.32617e-05,  2.78924e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.20882e-05,  4.31918e-05,   2.6159e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.30779e-05,  4.03052e-05,  2.77246e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.41726e-05,  3.58867e-05,  2.29003e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.84078e-05,  2.79764e-05,  2.40926e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.38403e-05,   2.2182e-05,  1.83168e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.82822e-05,  2.43191e-05,   1.7835e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.06602e-05,  2.41549e-05,  1.71117e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.38257e-05,  3.33495e-05,  2.16674e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  5.00904e-05,  4.22893e-05,  2.45722e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  5.23528e-05,  2.87789e-05,  2.30049e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.91255e-05,  4.22279e-05,  2.12571e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  7.57127e-05,  3.81671e-05,  1.97633e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  4.88258e-05,  2.74012e-05,  1.17436e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.81908e-05,  1.64891e-05,  8.53989e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  3.16542e-05,   1.0427e-05,  6.04788e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(  2.03894e-05,  1.30753e-05,  5.58264e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.28996e-05,  5.93574e-06,   5.1332e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  4.15527e-05,   1.6054e-05,  4.37002e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(    5.073e-05,  1.63265e-05,  5.81571e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  5.15382e-05,  2.06282e-05,   8.5748e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  6.67903e-05,  2.87648e-05,  1.41153e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  4.11133e-05,  2.43071e-05,  1.79761e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.17523e-05,  2.13407e-05,  1.38298e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.84663e-05,   2.4444e-05,  1.03918e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(   1.9574e-05,  2.27912e-05,  1.31632e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.00519e-05,    1.757e-05,  9.24668e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.40026e-05,  1.74496e-05,  1.41633e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.73354e-05,  1.47544e-05,  1.34286e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.11531e-05,  1.74219e-05,  1.78318e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.22644e-05,   2.1877e-05,  1.44766e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(   2.6938e-05,  2.36991e-05,  1.70768e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.07808e-05,  1.81225e-05,  1.89823e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.90005e-05,    2.052e-05,  1.32998e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.19591e-05,  2.41175e-05,  1.94619e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.81259e-05,  1.57008e-05,  1.25317e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.42168e-05,   1.6349e-05,   1.1301e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.96973e-05,  1.64988e-05,  1.26286e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.00076e-05,  1.70619e-05,  8.70992e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.46219e-05,  1.62588e-05,  1.07105e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.76047e-05,  1.98996e-05,   1.4128e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.16565e-05,  2.19425e-05,  1.81519e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.95633e-05,  2.21172e-05,  1.16626e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.41743e-05,   1.8466e-05,  1.23278e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  3.14549e-05,  2.13468e-05,  9.35293e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.74107e-05,  1.55516e-05,  9.66965e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  2.33441e-05,  1.05949e-05,  7.42975e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(  1.99075e-05,  7.54008e-06,  7.39367e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.71738e-05,  7.96317e-06,   6.0677e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.39456e-05,  8.22421e-06,  5.03489e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.87406e-05,   7.5908e-06,  3.42627e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.24832e-05,  1.09507e-05,  4.25239e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.88269e-05,  1.58477e-05,  6.12311e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  3.97325e-05,  2.49371e-05,  5.45468e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.50423e-05,  1.19662e-05,  1.03637e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.61269e-05,   8.7006e-06,  8.80219e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.28123e-05,  7.95835e-06,  7.34767e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.23928e-05,  1.02801e-05,  9.28256e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.33005e-05,  1.34679e-05,  9.51493e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.54043e-05,   1.3649e-05,  7.71525e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.60326e-05,  1.10691e-05,  7.88461e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.36113e-05,  1.63021e-05,  1.01216e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.50824e-05,  1.20596e-05,  1.02626e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.28195e-05,  1.71132e-05,   1.2813e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.85902e-05,  1.54022e-05,  9.47502e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.98836e-05,  1.46468e-05,  1.26301e-05) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.82447e-05,  1.04982e-05,  7.39947e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.35878e-05,   1.2931e-05,  7.83627e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.19905e-05,  8.35438e-06,  6.41957e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.18394e-05,  1.07861e-05,   8.8579e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.36113e-05,  7.39907e-06,   7.0633e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(   6.5865e-06,  6.97309e-06,  7.46899e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(     1.93e-05,  1.07305e-05,  8.18917e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.71732e-05,  1.29395e-05,  9.13822e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.58895e-05,  1.39478e-05,  8.81846e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.40741e-05,  1.13063e-05,  8.00687e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.27273e-05,  1.28887e-05,  7.21013e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  2.00522e-05,  1.00706e-05,  5.85572e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(  1.73067e-05,  9.41114e-06,  7.55407e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.30304e-05,    4.812e-06,  5.28526e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  2.26773e-05,  8.66026e-06,  6.44557e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.88349e-05,  1.14471e-05,  4.36005e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.39761e-05,  9.87588e-06,  3.82823e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.39665e-05,  5.31475e-06,  4.59503e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.31709e-05,  5.76701e-06,  5.28104e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.77108e-05,  6.54953e-06,   4.8809e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.04327e-05,  6.35855e-06,  5.41539e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  8.80301e-06,  8.02001e-06,  5.69113e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(   9.9639e-06,  6.16524e-06,  4.93549e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.01067e-05,  7.60143e-06,  6.30571e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  9.81269e-06,  9.73525e-06,   7.9921e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.16626e-05,  7.48992e-06,    5.964e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.63512e-05,   1.1062e-05,  8.57364e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.43359e-05,  7.94545e-06,  7.60685e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.17581e-05,  1.07815e-05,  7.79535e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(   1.4023e-05,  6.72353e-06,  6.36124e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.51641e-05,   1.0286e-05,  9.79083e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.21674e-05,  9.48334e-06,  5.97159e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.12792e-05,  6.98596e-06,  6.62688e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.08623e-05,  6.86565e-06,  5.18577e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  9.04654e-06,  5.62273e-06,  5.28018e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.14216e-05,  7.86838e-06,  6.58123e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.08686e-05,   2.9446e-06,  5.63335e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.13781e-05,  4.54732e-06,  6.49348e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.28567e-05,  8.09435e-06,  8.77696e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.12711e-05,  9.43578e-06,  6.92584e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(   1.9855e-05,  8.91141e-06,  4.52999e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.26188e-05,   6.5302e-06,  6.32184e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  9.24498e-06,   6.4584e-06,  6.23515e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(  1.40805e-05,  3.50222e-06,  6.02023e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.67902e-06,  3.56842e-06,  3.88455e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  8.71142e-06,  4.12425e-06,  3.56396e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   1.3494e-05,  4.04859e-06,  3.56103e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.66732e-05,  7.60991e-06,  4.13404e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.64266e-06,  6.36846e-06,  3.83836e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.11639e-06,   5.9722e-06,  3.56302e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  3.69939e-06,  5.71775e-06,    3.517e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  7.43543e-06,  4.28287e-06,  3.87646e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  7.20138e-06,  7.80821e-06,  3.61949e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  9.12364e-06,  6.52148e-06,  3.63826e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  8.48244e-06,  5.76409e-06,  4.63021e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  8.12813e-06,   6.1675e-06,  4.45413e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  7.72601e-06,  4.83727e-06,  4.37419e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  9.72161e-06,  7.75678e-06,  5.68111e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.80046e-06,  8.30992e-06,  5.17471e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.05089e-05,  7.61459e-06,   6.1097e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   7.0647e-06,  6.43131e-06,  4.76317e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  1.06353e-05,  9.12669e-06,  6.35463e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  8.54379e-06,  6.21128e-06,  5.25673e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.42124e-06,   5.4554e-06,  3.98973e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  9.27537e-06,  6.15305e-06,  3.12419e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  5.25339e-06,  4.76168e-06,  3.39981e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  5.14769e-06,  4.87737e-06,  3.96912e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.87669e-06,  5.00564e-06,  4.14815e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   4.4011e-06,   4.5035e-06,  5.06017e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  4.22156e-06,  6.69386e-06,  3.79882e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  5.60864e-06,  5.65504e-06,  4.67974e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  9.13502e-06,  4.62077e-06,  4.24215e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(   9.4105e-06,  6.05556e-06,    4.599e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  8.41315e-06,  6.09119e-06,  3.96063e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(  6.79146e-06,  5.46669e-06,  3.63489e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  6.87001e-06,  2.43186e-06,  4.26244e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.22398e-06,  2.98181e-06,  4.96282e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  3.82352e-06,  3.15589e-06,  3.32033e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.60442e-06,  3.75545e-06,  2.98506e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(   4.7124e-06,  4.73633e-06,  3.61366e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.68544e-06,  3.41192e-06,  3.21421e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.10143e-06,  3.36422e-06,  3.60659e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.73665e-06,   3.1865e-06,  2.86787e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.24088e-06,  3.70175e-06,  3.67227e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.31659e-06,  5.01244e-06,  3.25355e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  7.86444e-06,  4.94056e-06,  3.63456e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(   6.0142e-06,  3.74798e-06,   2.9015e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.53075e-06,  4.71765e-06,  2.85148e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  7.77868e-06,  7.00792e-06,  4.60861e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(   5.6054e-06,  4.40816e-06,  4.23031e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  9.11374e-06,   4.9634e-06,   4.1526e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.80812e-06,  4.98499e-06,  4.08431e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.26179e-06,  4.96774e-06,  4.65276e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  7.48584e-06,   5.9049e-06,  4.91349e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.87415e-06,   3.5795e-06,  2.94215e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.30184e-06,  4.32354e-06,  3.55299e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.38649e-06,  3.44357e-06,  2.61929e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  3.49497e-06,  3.12877e-06,  4.09571e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.89782e-06,  4.83572e-06,  3.60681e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.56669e-06,  3.44209e-06,  2.85133e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.16687e-06,  2.88592e-06,  3.84338e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  4.07039e-06,  3.64284e-06,  4.32724e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  2.97317e-06,  4.92839e-06,  3.32451e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(   7.1002e-06,  6.39171e-06,  5.44434e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(   7.1703e-06,  3.81343e-06,  4.95102e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(  5.59759e-06,  4.83299e-06,  3.66809e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  7.15591e-06,  2.47939e-06,  2.50234e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.68663e-06,  2.32219e-06,  2.67518e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.14204e-06,  3.15037e-06,  3.20759e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.40398e-06,   2.2371e-06,  1.95722e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   3.7213e-06,    2.513e-06,  2.77031e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.91211e-06,  2.17561e-06,  2.47756e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.94018e-06,    3.002e-06,   2.4365e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.41771e-06,  3.40649e-06,   2.3932e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.52303e-06,  2.60237e-06,  2.32454e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.27908e-06,  3.88172e-06,  2.90292e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.46969e-06,  3.96358e-06,   3.0848e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.00586e-06,  3.55804e-06,  2.29789e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.55817e-06,  4.56954e-06,  2.56557e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  6.27343e-06,  3.49295e-06,  3.83439e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   6.3675e-06,  5.05117e-06,  2.59573e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.80817e-06,  4.54222e-06,  3.70118e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.73766e-06,  4.96984e-06,   2.3091e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.67148e-06,  3.20018e-06,  3.28139e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  8.16577e-06,  5.66651e-06,   4.2025e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.12404e-06,  2.90666e-06,  2.33741e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.77137e-06,  4.08839e-06,  2.69967e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.68613e-06,  2.58782e-06,  2.03386e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.07993e-06,  3.21662e-06,  2.46989e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(   3.6444e-06,  2.77775e-06,  2.76275e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  4.88755e-06,   3.4649e-06,  2.59559e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.02576e-06,  2.84305e-06,  2.30191e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  2.84164e-06,  4.19817e-06,   2.1216e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  6.56728e-06,   3.5009e-06,  2.03745e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  3.69262e-06,  5.09111e-06,  2.64234e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.25991e-06,  3.90556e-06,  3.06947e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(  5.25816e-06,  3.37571e-06,  3.54129e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(   2.7273e-06,  3.10962e-06,  2.66961e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.21388e-06,  2.77299e-06,  2.47772e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.78777e-06,  2.50416e-06,  2.41018e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.69909e-06,  1.90098e-06,  2.85248e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.72071e-06,  2.48031e-06,  2.19151e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.78545e-06,   2.4641e-06,  2.07905e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.58548e-06,  1.87443e-06,   2.9257e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.17447e-06,  2.52589e-06,  1.92068e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.79863e-06,  1.82812e-06,  2.00108e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.20575e-06,  3.71354e-06,  2.51099e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.80023e-06,  2.44409e-06,   2.3706e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.15529e-06,    2.642e-06,   2.0912e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.59344e-06,  2.66575e-06,  2.31333e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.99273e-06,  3.79125e-06,   3.5547e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(    4.197e-06,  2.71557e-06,  2.47141e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.02393e-06,  3.54006e-06,  3.54357e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.92805e-06,  3.12086e-06,  2.01095e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.77211e-06,  2.69436e-06,  3.15722e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  4.82233e-06,    3.832e-06,  3.26501e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.41662e-06,  3.46085e-06,  2.20419e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.78002e-06,  2.26238e-06,   2.0276e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.89801e-06,  2.51247e-06,  1.79525e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.88771e-06,  1.83372e-06,  1.88938e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.31477e-06,  1.73628e-06,  2.20437e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.65552e-06,  2.49347e-06,  2.57054e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  3.39369e-06,    2.939e-06,  1.66027e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.13721e-06,  1.96572e-06,  2.52321e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.37565e-06,  3.11121e-06,  2.86688e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.25015e-06,  1.93728e-06,  3.28901e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.46694e-06,  2.66041e-06,  3.09743e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(  2.78144e-06,  3.34888e-06,  3.18499e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.08828e-06,  2.15111e-06,   2.6556e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.04642e-06,  2.04387e-06,  2.17279e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.16595e-06,  1.91354e-06,  2.12367e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.70971e-06,  2.40502e-06,  2.01119e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.31523e-06,  1.99429e-06,  1.80292e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.83765e-06,  2.01613e-06,  1.57244e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.09903e-06,  2.26018e-06,  1.61004e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(     2.71e-06,  2.15118e-06,  1.78509e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.76655e-06,   1.9939e-06,  1.85948e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.21568e-06,  2.43725e-06,  1.93442e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.22517e-06,  1.52475e-06,  2.17685e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.36886e-06,  1.85975e-06,  1.25962e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  4.11749e-06,  2.63194e-06,  2.14233e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.15838e-06,  2.18437e-06,  2.88665e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.12136e-06,  2.81905e-06,  2.04256e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   3.4058e-06,  2.35433e-06,  3.38589e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.58451e-06,  2.58513e-06,  1.50184e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   1.8132e-06,  2.35782e-06,  2.93635e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   4.2249e-06,  3.53576e-06,  2.52954e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  3.13106e-06,  2.72577e-06,  1.89872e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.34606e-06,  2.00256e-06,   2.0458e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(   2.4701e-06,  2.36513e-06,  1.71409e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.62975e-06,  1.67702e-06,  2.36197e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.88169e-06,  1.92135e-06,  1.94827e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.99008e-06,  1.88859e-06,  2.52395e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.80606e-06,  2.47673e-06,  2.64597e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.68077e-06,  1.76781e-06,  2.10459e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  1.64895e-06,  1.76136e-06,  2.07327e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.44281e-06,  2.46126e-06,  2.29267e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.56354e-06,  2.71491e-06,  1.90377e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(  2.49475e-06,  2.17922e-06,  2.02067e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.48217e-06,  1.11363e-06,  2.31854e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.45332e-06,  1.59722e-06,  2.25675e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.34086e-06,  1.83516e-06,  2.03742e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.01591e-06,  1.35237e-06,  1.49811e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(   1.8981e-06,  1.42447e-06,  2.14806e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.10667e-06,  1.73729e-06,  2.25562e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.60195e-06,  1.13424e-06,  1.73538e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.38274e-06,  1.70469e-06,  1.86394e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.36522e-06,  2.29072e-06,  1.84885e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.24784e-06,  1.81825e-06,  1.86353e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.40448e-06,  1.37634e-06,  1.66531e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.03022e-06,  1.83857e-06,  1.45222e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.94746e-06,  2.48896e-06,  2.09471e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.17252e-06,  2.09058e-06,  2.84399e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  3.26604e-06,  1.74202e-06,  1.59088e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.86242e-06,  2.12783e-06,  3.23808e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.63037e-06,   2.4485e-06,  1.44497e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.65963e-06,  1.31426e-06,  2.91509e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  3.44548e-06,  2.37448e-06,  2.03266e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.87929e-06,  3.06573e-06,     1.66e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.10409e-06,   1.5009e-06,  2.13901e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.50836e-06,  1.89674e-06,   1.6578e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.82921e-06,  1.48074e-06,  1.75969e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.58043e-06,  1.23281e-06,  2.15735e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.04169e-06,  1.38477e-06,  1.86869e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  1.67319e-06,  1.82786e-06,  2.15295e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.21585e-06,  2.33185e-06,  3.00411e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.55713e-06,  1.45964e-06,  2.57733e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.10742e-06,   1.7175e-06,  2.76988e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.18782e-06,  1.67123e-06,  2.02687e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(  2.00458e-06,   1.2642e-06,  1.82714e-06) * texture2DRect(se_rgbaTex, pos).xyz;
    
    gl_FragColor = vec4(rgb.x, rgb.y, rgb.z, rgba.w);
    return;
}