/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * diffraction slit
 * @brief ܌tB^iXbgj
 * 
 * @param F Fl
 *
 * ܂ɂu[ʂV~[g܂D
 * i`̓XbgłD
 *
 * Reference ::
 * Kakimoto M., Matsuoka K., Nishita T., Naemura T., Harashima H.
 * "Glare generation based on wave optics".
 * Computer Graphics Forum, Vol. 24, No. 2. pp.185--193, 2005-7.
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
#extension GL_ARB_texture_rectangle: enable

// Screen Efects󂯎
uniform sampler2DRect se_rgbaTex;    // RGBA
uniform vec2 se_screenSize;
uniform float se_cameraZoom;
uniform float se_cameraFocus;

/* -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8
 * main
 * -+----1----+----2----+----3----+----4----+----5----+----6----+----7----+-- */
void main(void) {
    vec2 uvPos = gl_FragCoord.xy;
    vec2 pos;
    vec4 rgba = texture2DRect(se_rgbaTex, uvPos).xyzw;
    vec3 rgb = vec3(0.0, 0.0, 0.0);
    
    // Fl
    float FValue = 1.0e+9;
    if (se_cameraFocus != 0.0) {
        FValue = 2.0 * 36.0 * (0.001 * se_cameraZoom) * (0.001 * se_cameraZoom)
                 / se_cameraFocus;
    }
    if (FValue > 512.0) {
        FValue = 512.0;
    }
    
    float pixWidth = max(se_screenSize.x, se_screenSize.y);
    float dotPitch = 0.036 / pixWidth;
    float airyRadius = 1.2196 * 435.8e-9 * FValue;
    float airyZeroPoint = 4.61089134947891;    
    float scalingFactor = airyRadius / airyZeroPoint / dotPitch;    // J[lԂ1pxXN[ŉpxɑ邩
    
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (-1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000341715,  0.000321594,  0.000346834) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000419738,  0.000326429,  0.000425879) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00047854,  0.000353942,  0.000315335) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000544062,  0.000412209,  0.000485259) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000556538,  0.000502368,  0.000402378) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000568214,  0.000618823,  0.000509768) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000797386,  0.000641613,  0.000646614) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000801992,  0.000906148,  0.000562021) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00112494,   0.00111128,   0.00108036) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00170609,   0.00137828,  0.000862292) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00261294,   0.00179966,   0.00184734) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00419712,   0.00262061,   0.00219405) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00718234,   0.00458316,   0.00400489) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(     0.018591,    0.0109788,    0.0107145) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(    0.0825854,    0.0639677,     0.032758) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(     0.709906,     0.786196,     0.872943) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(     0.124431,    0.0939921,    0.0451198) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(    0.0210755,    0.0131435,    0.0103864) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00790116,   0.00506953,   0.00471649) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00426304,   0.00271807,   0.00200637) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00258794,   0.00177595,   0.00199063) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00161067,   0.00132915,  0.000868053) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(   0.00107026,   0.00107781,   0.00104725) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000818124,  0.000901802,  0.000633891) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000837593,  0.000657297,  0.000581558) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000628934,  0.000640761,  0.000566004) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000608371,   0.00053349,  0.000373283) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000556375,  0.000439488,  0.000492405) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000482511,  0.000368208,  0.000335608) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000398466,  0.000325107,  0.000392915) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 0.0) * scalingFactor;
    rgb += vec3(  0.000316037,  0.000308668,  0.000391037) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 1.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 2.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 3.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 4.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 5.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 6.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 7.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 8.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + ( 9.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (10.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (11.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (12.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (13.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (14.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-15.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-14.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-13.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-12.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-11.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-10.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-9.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-8.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-7.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-6.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-5.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-4.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-3.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-2.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (-1.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 0.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 1.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 2.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 3.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 4.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 5.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 6.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 7.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 8.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + ( 9.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (10.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (11.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (12.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (13.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (14.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    pos.x = uvPos.x + (15.0) * scalingFactor;
    pos.y = uvPos.y + (15.0) * scalingFactor;
    rgb += vec3(          0.0,          0.0,          0.0) * texture2DRect(se_rgbaTex, pos).xyz;
    
    gl_FragColor = vec4(rgb.x, rgb.y, rgb.z, rgba.w);
    return;
}